package com.example.ivan.ponsi;

import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.URLUtil;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by Ivan on 20/10/2015.
 */
public class AdapadorClientes extends CursorAdapter {
    private LayoutInflater inflador;
    TextView nombre,alias,telefono,localidad;
    ImageView foto;

    public AdapadorClientes(Context contexto, Cursor c){
        super(contexto, c, false);
    }

    @Override
    public View newView(Context contexto, Cursor c, ViewGroup padre){
        inflador = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vista = inflador.inflate(R.layout.elemento_lista_clientes, padre,false);
        return vista;
    }

    @Override
    public void bindView(View vista, Context contexto, Cursor c) {
        nombre = (TextView) vista.findViewById(R.id.nombre_list);
        alias = (TextView) vista.findViewById(R.id.alias_list);
        localidad = (TextView) vista.findViewById(R.id.localidad_list);
        telefono = (TextView) vista.findViewById(R.id.telefono_list);
        foto = (ImageView) vista.findViewById(R.id.foto_cliente_list);


        nombre.setText(c.getString(c.getColumnIndex("nombre"))+" "+c.getString(c.getColumnIndex("apellidos")));
        alias.setText(c.getString(c.getColumnIndex("alias")));
        localidad.setText(c.getString(c.getColumnIndex("ciudad")));
        int tele = c.getInt(c.getColumnIndex("telefono"));
        if(tele!=0) {
            telefono.setText(Integer.toString(tele));
        }

        String fotos = c.getString(c.getColumnIndex("foto"));
        if (URLUtil.isValidUrl(fotos)) {

            foto.setImageURI(Uri.parse(fotos));
        } else {
            foto.setImageResource(R.drawable.perfil);
        }
        //foto.setScaleType(ImageView.ScaleType.FIT_END);

    }
}
