package com.example.ivan.ponsi;

import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.URLUtil;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by Ivan on 20/10/2015.
 */
public class AdaptadorParcelas extends CursorAdapter {
    private LayoutInflater inflador;
    TextView paraje,finca,localidad;
    ImageView foto;

    public AdaptadorParcelas(Context contexto, Cursor c){
        super(contexto, c, false);
    }

    @Override
    public View newView(Context contexto, Cursor c, ViewGroup padre){
        inflador = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vista = inflador.inflate(R.layout.elemento_lista_parcelas, padre,false);
        return vista;
    }

    @Override
    public void bindView(View vista, Context contexto, Cursor c) {
        paraje = (TextView) vista.findViewById(R.id.paraje_list);
        finca = (TextView) vista.findViewById(R.id.finca_list);
        localidad = (TextView) vista.findViewById(R.id.ciudad_list);
        foto = (ImageView) vista.findViewById(R.id.foto_parcela_list);


        paraje.setText(c.getString(c.getColumnIndex("paraje")));
        finca.setText(c.getString(c.getColumnIndex("finca")));
        localidad.setText(c.getString(c.getColumnIndex("ciudad")));


        String fotos = c.getString(c.getColumnIndex("fotofinca"));
        if (URLUtil.isValidUrl(fotos)) {
            //Toast.makeText(FichaCliente.this, "uri "+uri, Toast.LENGTH_LONG).show();
            foto.setImageURI(Uri.parse(fotos));
        } else {
            foto.setImageResource(R.drawable.campo);
        }
        //foto.setScaleType(ImageView.ScaleType.FIT_END);

    }
}


