package com.example.ivan.ponsi;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;

import java.util.Vector;

/**
 * Created by Ivan on 18/10/2015.
 */
public class ConsultaBD {

    private static BaseDeDatos BaseDeDatos;

    public static void inicializaBD(Context contexto){
        BaseDeDatos = new BaseDeDatos(contexto);
    }

    public static Cursor listadoClientes(){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT clientes_id AS _id, * FROM clientes, local WHERE localidad = local_id", null);
    }

    public static Cursor listadoProductos(){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT producto_id AS _id, * FROM productos ORDER BY nombre_p", null);
    }
    public static Cursor listadoAbonos(){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT abono_id AS _id, * FROM abonos ORDER BY nombre_a", null);
    }

    public static Cursor listadoParcelas(int id){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT fincas_id AS _id, * FROM fincas, clientes, local " +
                "WHERE propietario = clientes_id AND poble = local_id AND clientes_id = "+id, null);
    }

    public static Cursor listadoTareas(int id){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT tareas_id AS _id, * FROM tareas "+
                "WHERE  sitio = "+id+" ORDER BY fecha DESC" , null);
    }

    public static Cursor listadoTareasPendientes(){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT pendiente_id AS _id, * FROM pendiente, fincas,clientes "+
                "WHERE  sitio = fincas_id AND clientes_id = propietario ORDER BY fecha DESC" , null);
    }

    public static Cursor listadoFito(int id){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT * FROM fitos, productos, t_cantidad, t_dosis " +
                "WHERE producto = producto_id AND cant_s = t_cantidad_id AND " +
                "dosis_s = t_dosis_id AND tarea = "+id, null);
    }

    public static Cursor listadoAbonado(int id){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT * FROM abonado, abonos " +
                "WHERE abono = abono_id  AND " +
                " tarea = "+id, null);
    }
    public static Cursor listadoSectores(int id){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT * FROM sectores " +
                "WHERE  tarea = "+id, null);
    }
    public static Cursor listadoProgramas(int id){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT * FROM programas " +
                "WHERE  sector = "+id, null);
    }

    public static Cursor listadoOtros(int idt){
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        return bd.rawQuery("SELECT * FROM otros WHERE tarea = "+idt, null);
    }

    public static String textoOtros(int idt){
        String realizado=null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM otros WHERE tarea = "+idt, null);
        if(c.moveToNext()){

            realizado =""+c.getString((c.getColumnIndex("realizado")));
        }
        c.close();
        bd.close();
        return realizado;

    }

    public static int lecturaContador(int tarea){
        int lectura = -1;
        int vista=0;

        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM contador WHERE trabajo = "+tarea, null);
        if(c.moveToNext()){

            lectura =0+c.getInt((c.getColumnIndex("lectura")));
            vista = c.getInt(c.getColumnIndex("visible"));
        }
        c.close();
        bd.close();
        if(vista==0){
            lectura=-1;
        }
        return lectura;
    }


    public static int nuevoCliente(){
        int id = -1;
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("INSERT INTO clientes (nombre) VALUES ('')");
        Cursor c = bd.rawQuery("SELECT * FROM clientes WHERE nombre = ''", null );
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;
    }

    public static  int nuevaParcela(int id2){

        int id = -1;
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("INSERT INTO fincas (propietario,paraje) VALUES ("+id2+", '')");
        Cursor c = bd.rawQuery("SELECT * FROM fincas WHERE paraje = '' AND propietario = "+id2, null );
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;

    }

    public static int nuevaTarea(int id_parcela, int id_tipo_tarea){
        int id = -1;
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("INSERT INTO tareas (sitio, tipo_t, titulo, fecha, observaciones) VALUES ("+id_parcela +" , "+ id_tipo_tarea+", '', 1, '')");
        Cursor c = bd.rawQuery("SELECT * FROM tareas WHERE fecha = 1 AND titulo = '' " +
                "AND sitio = "+id_parcela+" AND tipo_t = "+id_tipo_tarea, null );
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;

    }

    public static  int nuevaTareaPendiente(int id2){

        int id = -1;
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("INSERT INTO pendiente (sitio, fecha) VALUES ("+id2+", 1)");
        Cursor c = bd.rawQuery("SELECT * FROM pendiente WHERE fecha = 1 AND sitio = "+id2, null );
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;

    }

    public static void nuevoFitosanitario(int tarea, Fitosanitario fito){

        int id_cant = getCantidad(fito.getsCantidad());
        int id_dosis = getDosis(fito.getsDosis());
        int id_prod = getProductoComercial(fito);
        String insertar="INSERT INTO fitos  VALUES ( null,'" + fito.getMotivo() + "', " +
                fito.getCantidad() + ", " + fito.getCaldo() + ", " + fito.getPs() + ", " +
                fito.getDosis() + ", " + tarea + ", " + id_cant + ", " +
                id_dosis + ", " + id_prod + ")";




        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL(insertar);
    }

    public static void nuevoAbonado(int tarea, Abonado fito){

        //int id_dosis = getDosis(fito.getsDosis());
        int id_prod = getAbono(fito);
        String insertar="INSERT INTO abonado  VALUES ( null," +fito.getCantidad() +", " + fito.getDosis() + ", '" +fito.getMotivo() + "', " +fito.getT_cantidad() +", "+ tarea + ", " + fito.getsDosis() + ", " + id_prod + ")";


        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL(insertar);
    }
    public static int nuevoSector(int tarea, Sector sector){
        int id=-1;
        String insertar="INSERT INTO sectores  VALUES ( null, '" +
                sector.getNom() +
                "', " + sector.getPresio() +
                ", '" +sector.getAbonadora() +
                "', " +sector.getS_abonadora() +
                ", "+ tarea+")";


        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL(insertar);

        Cursor c = bd.rawQuery("SELECT * FROM sectores WHERE tarea =  " + tarea +" AND n_sector = '"+ sector.getNom()+"'", null );
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;
    }
    public static void nuevoPrograma(int tarea, Programa pro){

        String insertar="INSERT INTO programas  VALUES ( null, '" +
                pro.getDias() +
                "', " + pro.getInicio() +
                ", " +pro.getFin() +
                ", "+ tarea+")";


        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL(insertar);
    }

    public  static int nuevoProducto(Producto producto){
        int id=-1;
        String insertar = "INSERT INTO productos  VALUES ( null, '" +
                producto.getNombre() + "', '" +
                producto.getMateria() +"', null, '" +
                producto.getObservaciones() + "', "+
                producto.getRegistro()+", "+
                producto.getTipo()+", null, '" +
                producto.getFoto()+ "', '" +
                producto.getFabricante()+ "' )";

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL(insertar);
        Cursor c = bd.rawQuery("SELECT * FROM productos WHERE nombre_p = '" + producto.getNombre()
                +"' AND mat_act = '"+ producto.getMateria()
                +"' AND n_registro = "+producto.getRegistro(), null );
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;

    }
    public  static int nuevoAbono(Producto producto){
        int id=-1;
        String insertar = "INSERT INTO abonos  VALUES ( null, '" +
                producto.getNombre() + "', '" +
                producto.getMateria() +"', null, '" +
                producto.getObservaciones() + "', "+
                producto.getRegistro()+", '"+
                producto.getFabricante()+"', null, '" +
                producto.getFoto()+ "' )";

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL(insertar);

        Cursor c = bd.rawQuery("SELECT * FROM abonos WHERE nombre_a = '" + producto.getNombre()
                +"' AND mat_act = '"+ producto.getMateria()
                +"' AND n_registro = "+producto.getRegistro(), null );
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;

    }

    public static void nuevoOtros(int idt, String realizado){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("INSERT INTO otros  VALUES ( null, '" + realizado + "' , " + idt + ")");

    }
    public static void nuevaLectura(int idt, int lectura, boolean vista ){
        int vis=0;
        if(vista){vis=1;}
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("INSERT INTO contador  VALUES ( null, " + lectura + " , " + vis + ", " + idt + ")");

    }

    public static void borrarCliente(int id) {

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM clientes WHERE clientes_id = " + id);
        bd.close();
    }
    public static void borrarAbono(int id) {

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM abonos WHERE abono_id = " + id);
        bd.close();
    }
    public static void borrarProducto(int id) {

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM productos WHERE producto_id = " + id);
        bd.close();
    }
    public static void borrarParaje(int id) {

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM fincas WHERE fincas_id = " + id);
        bd.close();
    }
    public static void borrarTarea(int id) {

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM tareas WHERE tareas_id = " + id);
        bd.close();
    }
    public static void borrarTareaPendiente(int id) {

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM pendiente WHERE pendiente_id = " + id);
        bd.close();
    }
    public static void borrarFito(int id){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM fitos WHERE fito_id = " + id);
        bd.close();
    }
    public static void borrarAbonado(int id){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM abonado WHERE abonado_id = " + id);
        bd.close();
    }
    public static void borrarSector(int id){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM sectores WHERE sector_id = " + id);
        bd.close();
    }
    public static void borrarPrograma(int id){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("DELETE FROM programas WHERE programa_id = " + id);
        bd.close();
    }




    public static void actualizarCliente(int id, Cliente cliente){


        int id_loc = nuevaLocalidad(cliente);
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();

        bd.execSQL("UPDATE clientes SET nombre = '"+ cliente.getNombre() +
                "', apellidos = '" + cliente.getApellidos() +
                "', alias = '" + cliente.getAlias() +
                "', direccion = '" + cliente.getDireccion() +
                "', telefono = " + cliente.getTelefono() +
                ", telefono2 = " + cliente.getTelefono2() +
                ", email = '" + cliente.getEmail() +
                "', foto = '" + cliente.getFoto() +
                "', dni = '" + cliente.getDni() +
                "', localidad = " + id_loc +
                " WHERE  clientes_id = " + id);
        bd.close();

    }

    public static void actulizarParcela(int id, Parcela cliente){
        int id_loc = nuevaLocalidad(cliente);
        int id_sup = nuevaSuper(cliente);
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();

        bd.execSQL("UPDATE fincas SET finca = '"+ cliente.getFinca() +
                "', tipo_cult = '" + cliente.getCultivo() +
                "', paraje = '" + cliente.getParaje() +
                "', poligono = " + cliente.getPoligono() +
                ", parcela = " + cliente.getParcela() +
                ", superficie = " + cliente.getSuperficie() +
                ", fotofinca = '"+ cliente.getFoto() +
                "', spin_superficie = " + id_sup +
                ", poble = " + id_loc +
                " WHERE  fincas_id = " + id);
        bd.close();

    }

    public static void actualizarTarea(int id, Tarea tarea){

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();

        bd.execSQL("UPDATE tareas SET titulo = '"+ tarea.getTitulo() +
                "', fecha = "+ tarea.getFecha() +
                ", observaciones = '"+tarea.getObservaciones()+
                "', tiempo = "+ tarea.getTiempo()+
                ", coste = "+ tarea.getCoste()+
                ", tiempo_s = "+ tarea.getsTiempo()+
                " WHERE  tareas_id = " + id);

        bd.close();

    }
    public static void actualizarTareaPendiente(int id, TareaPendiente tarea){

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();

        bd.execSQL("UPDATE pendiente SET titulo = '"+ tarea.getTitulo() +
                "', fecha = "+ tarea.getFecha() +
                ", observaciones = '"+tarea.getObservaciones()+
                "', tipo =  " +tarea.getTipo()+
                ", tarea = '" +tarea.getRealizada()+
                "', prioridad = " +tarea.getPrioridad()+
                " WHERE  pendiente_id = " + id);

        bd.close();

    }

    public static void actualiarFitosanitario(int id, Fitosanitario fito){
        int id_cant = getCantidad(fito.getsCantidad());
        int id_dosis = getDosis(fito.getsDosis());
        int id_prod = getProductoComercial(fito);
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE fitos SET motivo = '" + fito.getMotivo() +
                "', cantidad = " + fito.getCantidad() +
                ", l_caldo = " + fito.getCaldo() +
                ", ps = " + fito.getPs() +
                ", dosis = " + fito.getDosis() +
                ", cant_s = " + id_cant +
                ", dosis_s = " + id_dosis +
                ", producto = " + id_prod +
                " WHERE fito_id = " + id);

        bd.close();
    }

    public static void actualiarAbonado(int id, Abonado fito){

        //int id_dosis =getDosis(fito.getsDosis());
        int id_prod = getAbono(fito);
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE abonado SET  motivo = '" + fito.getMotivo() +
                "', cantidad = " + fito.getCantidad() +
                ", dosis = " + fito.getDosis() +
                ", dosis_s = " + fito.getsDosis() +
                ", abono = " + id_prod +
                ", t_cantidad = " +fito.getT_cantidad() +
                " WHERE abonado_id = " + id);

        bd.close();
    }

    public static void actualiarSector(int id, Sector sector){

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE sectores SET  n_sector = '" + sector.getNom() +
                "', presio = " + sector.getPresio() +
                ", abonadora = " + sector.getAbonadora() +
                ", t_abonadora = " + sector.getS_abonadora() +
                " WHERE sector_id = " + id);

        bd.close();
    }
    public static void actualiarPrograma(int id, Programa pro){

        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE programas SET  dias = '" + pro.getDias() +
                "', desde = " + pro.getInicio() +
                ", hasta = " + pro.getFin() +
                " WHERE programa_id = " + id);

        bd.close();
    }

    public static void actualizarOtros(int idt, String realizado){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE otros SET realizado = '"+realizado +
                "' WHERE tarea = " + idt);
        bd.close();

    }

    public static void actualizarLectura(int idt, int lectura, boolean vista){
        int vis=0;
        if(vista){vis=1;}
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE contador SET lectura = " + lectura +
                ", visible = " + vis + " WHERE trabajo = " + idt);
        bd.close();

    }
    public static  void actualizarProducto(int id, Producto producto){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE productos SET nombre_p = '"+producto.getNombre() +
                "', mat_act = '" +producto.getMateria()+
                "', observacion = '" +producto.getObservaciones()+
                "', n_registro = " + producto.getRegistro()+
                ", tipo_fit = " + producto.getTipo()+
                ", imagen_p = '" +producto.getFoto()+
                "', fabricante = '" +producto.getFabricante()+
                "' WHERE producto_id = " + id);
        bd.close();
    }
    public static  void actualizarAbono(int id, Producto producto){
        SQLiteDatabase bd = BaseDeDatos.getWritableDatabase();
        bd.execSQL("UPDATE abonos SET nombre_a = '"+producto.getNombre() +
                "', mat_act = '" +producto.getMateria()+
                "', uso = '" +producto.getObservaciones()+
                "', n_registro = " + producto.getRegistro()+
                ", imagen_p = '" +producto.getFoto()+
                "', fabricante = '" +producto.getFabricante()+
                "' WHERE abono_id = " + id);
        bd.close();
    }

    public static int nuevaSuper(Parcela place){
        int id=-1;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM superficies WHERE tipo = " + place.gettSuperficie(), null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        return id;
    }

    public static int nuevaLocalidad(Cliente cliente){
        int id=-1;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM local WHERE ciudad = '" + cliente.getLocalidad()+
                "' AND pais = '"+cliente.getPais()+"'", null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        if(id == -1){
            SQLiteDatabase bd2 = BaseDeDatos.getWritableDatabase();
            bd2.execSQL("INSERT INTO local VALUES (null,  '"+
                    cliente.getLocalidad()+"', '"+
                    cliente.getZip()+"', '"+
                    cliente.getPais()+"', '"+
                    cliente.getProvincia()+"')");
            bd2.close();
            id=nuevaLocalidad(cliente);

        }
        return id;
    }

    public static int nuevaLocalidad(Parcela cliente){
        int id=-1;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM local WHERE ciudad = '" + cliente.getPoble()+"'", null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();
        if(id == -1){
            SQLiteDatabase bd2 = BaseDeDatos.getWritableDatabase();
            bd2.execSQL("INSERT INTO local VALUES (null,  '"+
                    cliente.getPoble()+"', "+
                    "null, " +
                    "null, '"+
                    cliente.getProvincia()+"')");
            bd2.close();
            id=nuevaLocalidad(cliente);

        }
        return id;
    }


    public static Cliente Cliente(int id){
        Cliente cliente = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM clientes, local WHERE localidad = local_id AND clientes_id = " + id, null);
        if (cursor.moveToNext()){
            cliente = new Cliente();
            cliente.setNombre(""+cursor.getString(cursor.getColumnIndex("nombre")));
            cliente.setApellidos(""+cursor.getString(cursor.getColumnIndex("apellidos")));
            cliente.setDireccion(""+cursor.getString(cursor.getColumnIndex("direccion")));
            cliente.setTelefono(0+cursor.getInt(cursor.getColumnIndex("telefono")));
            cliente.setTelefono2(0+cursor.getInt(cursor.getColumnIndex("telefono2")));
            cliente.setAlias(""+cursor.getString(cursor.getColumnIndex("alias")));
            cliente.setEmail(""+cursor.getString(cursor.getColumnIndex("email")));
            cliente.setDni(""+cursor.getString(cursor.getColumnIndex("dni")));
            cliente.setLocalidad(""+cursor.getString(cursor.getColumnIndex("ciudad")));
            cliente.setZip(""+cursor.getString(cursor.getColumnIndex("zip")));
            cliente.setPais(""+cursor.getString(cursor.getColumnIndex("pais")));
            cliente.setProvincia(""+cursor.getString(cursor.getColumnIndex("provincia")));
            cliente.setFoto(""+cursor.getString(cursor.getColumnIndex("foto")));
        }
        cursor.close();
        bd.close();

        return cliente;
    }

    public static  Producto Producto(int id){
        Producto producto = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM productos WHERE producto_id = " + id, null);
        if (cursor.moveToNext()){
            producto = new Producto();
            producto.setNombre(""+cursor.getString(cursor.getColumnIndex("nombre_p")));
            producto.setFabricante("" + cursor.getString(cursor.getColumnIndex("fabricante")));
            producto.setRegistro(0+cursor.getInt(cursor.getColumnIndex("n_registro")));
            producto.setTipo(0+cursor.getInt(cursor.getColumnIndex("tipo_fit")));
            producto.setMateria("" + cursor.getString(cursor.getColumnIndex("mat_act")));
            producto.setObservaciones(""+cursor.getString(cursor.getColumnIndex("observacion")));
            producto.setFoto(""+cursor.getString(cursor.getColumnIndex("imagen_p")));
        }
        cursor.close();
        bd.close();

        return producto;

    }
    public static  Producto Abono(int id){
        Producto producto = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM abonos WHERE abono_id = " + id, null);
        if (cursor.moveToNext()){
            producto = new Producto();
            producto.setNombre(""+cursor.getString(cursor.getColumnIndex("nombre_a")));
            producto.setFabricante(""+cursor.getString(cursor.getColumnIndex("fabricante")));
            producto.setRegistro(0+cursor.getInt(cursor.getColumnIndex("n_registro")));
            producto.setFoto(""+cursor.getString(cursor.getColumnIndex("imagen_p")));
            producto.setMateria(""+cursor.getString(cursor.getColumnIndex("mat_act")));
            producto.setObservaciones(""+cursor.getString(cursor.getColumnIndex("uso")));
        }
        cursor.close();
        bd.close();

        return producto;

    }

    public static Parcela Parcela (int id){
        Parcela place = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM fincas, clientes, local, superficies " +
                "WHERE propietario = clientes_id AND poble = local_id " +
                "AND spin_superficie = super_id AND fincas_id = "+ id, null);
        if (cursor.moveToNext()){
            place = new Parcela();
            place.setPropietario(""+cursor.getString(cursor.getColumnIndex("nombre")) + " " + cursor.getString(cursor.getColumnIndex("apellidos")));
            place.setAlias(""+cursor.getString(cursor.getColumnIndex("alias")));
            place.setParaje(""+cursor.getString(cursor.getColumnIndex("paraje")));
            place.setFinca(""+cursor.getString(cursor.getColumnIndex("finca")));
            place.setPoble(""+cursor.getString(cursor.getColumnIndex("ciudad")));
            place.setProvincia(""+cursor.getString(cursor.getColumnIndex("provincia")));
            place.setCultivo(""+cursor.getString(cursor.getColumnIndex("tipo_cult")));
            place.setPoligono(0+cursor.getInt(cursor.getColumnIndex("poligono")));
            place.setParcela(0+cursor.getInt(cursor.getColumnIndex("parcela")));
            place.setSuperficie(0+cursor.getFloat(cursor.getColumnIndex("superficie")));
            place.setTextsup(""+cursor.getString(cursor.getColumnIndex("tipo_texto")));
            place.setFoto(""+cursor.getString(cursor.getColumnIndex("fotofinca")));

        }
        cursor.close();
        bd.close();
        return place;
    }

    public static  TareaPendiente TareaPendiente (int id){
        TareaPendiente tarea = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM pendiente, fincas, clientes WHERE propietario = clientes_id AND fincas_id = sitio AND pendiente_id = "+ id,null);
        if (cursor.moveToNext()){
            tarea = new TareaPendiente();
            tarea.setNombre(""+cursor.getString(cursor.getColumnIndex("nombre")) + " " + cursor.getString(cursor.getColumnIndex("apellidos")));
            tarea.setAlia(""+cursor.getString(cursor.getColumnIndex("alias")));
            tarea.setParaje(""+cursor.getString(cursor.getColumnIndex("paraje")));
            tarea.setFinca(""+cursor.getString(cursor.getColumnIndex("finca")));
            tarea.setTitulo(""+cursor.getString(cursor.getColumnIndex("titulo")));
            tarea.setFecha(0+cursor.getFloat(cursor.getColumnIndex("fecha")));
            tarea.setObservaciones(""+cursor.getString(cursor.getColumnIndex("observaciones")));
            tarea.setTipo(0+cursor.getInt(cursor.getColumnIndex("tipo")));
            tarea.setRealizada(""+cursor.getString(cursor.getColumnIndex("tarea")));
            tarea.setPrioridad(0+cursor.getFloat(cursor.getColumnIndex("prioridad")));

        }
        cursor.close();
        bd.close();
        return tarea;
    }
    public static  Tarea Tarea (int id){
        Tarea tarea = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM tareas, fincas, clientes WHERE propietario = clientes_id AND fincas_id = sitio AND tareas_id = "+ id,null);
        if (cursor.moveToNext()){
            tarea = new Tarea();
            tarea.setNombre(cursor.getString(cursor.getColumnIndex("nombre")) + " " + cursor.getString(cursor.getColumnIndex("apellidos")));
            tarea.setAlia("" + cursor.getString(cursor.getColumnIndex("alias")));
            tarea.setParaje(""+cursor.getString(cursor.getColumnIndex("paraje")));
            tarea.setFinca(""+cursor.getString(cursor.getColumnIndex("finca")));
            tarea.setTitulo(""+cursor.getString(cursor.getColumnIndex("titulo")));
            tarea.setFecha(0+cursor.getFloat(cursor.getColumnIndex("fecha")));
            tarea.setObservaciones("" + cursor.getString(cursor.getColumnIndex("observaciones")));
            tarea.setTiempo(0+cursor.getDouble(cursor.getColumnIndex("tiempo")));
            tarea.setCoste(0+cursor.getDouble(cursor.getColumnIndex("coste")));
            tarea.setsTiempo(0+cursor.getInt(cursor.getColumnIndex("tiempo_s")));

        }
        cursor.close();
        bd.close();
        return tarea;
    }

    public static  Tarea TareaVacia (int id){
        Tarea tarea = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM tareas, fincas, clientes WHERE propietario = clientes_id AND fincas_id = sitio AND tareas_id = "+ id,null);
        if (cursor.moveToNext()){
            tarea = new Tarea();
            tarea.setNombre(""+cursor.getString(cursor.getColumnIndex("nombre")) + " " + cursor.getString(cursor.getColumnIndex("apellidos")));
            tarea.setAlia(""+cursor.getString(cursor.getColumnIndex("alias")));
            tarea.setParaje(""+cursor.getString(cursor.getColumnIndex("paraje")));
            tarea.setFinca(""+cursor.getString(cursor.getColumnIndex("finca")));
        }
        cursor.close();
        bd.close();
        return tarea;
    }
    public static  TareaPendiente TareaPendienteVacia (int id){
        TareaPendiente tarea = null;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM pendiente, fincas, clientes WHERE propietario = clientes_id AND fincas_id = sitio AND pendiente_id = "+ id,null);
        if (cursor.moveToNext()){
            tarea = new TareaPendiente();
            tarea.setNombre(""+cursor.getString(cursor.getColumnIndex("nombre")) + " " + cursor.getString(cursor.getColumnIndex("apellidos")));
            tarea.setAlia(""+cursor.getString(cursor.getColumnIndex("alias")));
            tarea.setParaje(""+cursor.getString(cursor.getColumnIndex("paraje")));
            tarea.setFinca(""+cursor.getString(cursor.getColumnIndex("finca")));
        }
        cursor.close();
        bd.close();
        return tarea;
    }

    public static String[] getSuperficies(){
        String[] result;
        Vector<String> res = new Vector<String>();
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM superficies", null);
        while(c.moveToNext()){
            res.add(c.getString(c.getColumnIndex("tipo_texto")));
        }
        c.close();
        bd.close();

        result = new String[res.size()];
        for(int j=0; j<res.size();j++){
            result[j] = res.get(j);
        }

        return result;
    }

    public static String[] getTipoTareas(){
        String[] result;
        Vector<String> res = new Vector<String>();
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM t_tareas", null);
        while(c.moveToNext()){
            res.add(c.getString(c.getColumnIndex("clave")));
        }
        c.close();
        bd.close();

        result = new String[res.size()];
        for(int j=0; j<res.size();j++){
            result[j] = res.get(j);
        }

        return result;
    }

    public static int getTipoTarea(int position){
        int id=-1;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM t_tareas WHERE tipo_val = " + position, null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();

        return id;
    }

    public static int getCantidad(int position){
        int id = -1;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM t_cantidad WHERE tipo_cant = " + position, null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();

        return id;

    }

    public static int getDosis(int position){
        int id = -1;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM t_dosis WHERE tipo_dosis = " + position, null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();

        return id;

    }

    public static int getProductoComercial(Fitosanitario fito){
      int id=-1;

      SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
      Cursor c = bd.rawQuery("SELECT * FROM productos WHERE nombre_p = '" + fito.getNombre()+"'", null);
      if(c.moveToNext()){
          id=c.getInt(0);
      }else{
          id = newProducto(fito);
      }
      c.close();
      bd.close();


      return id;
  }

    public static int newProducto(Fitosanitario fito){
        int id = -1;

        SQLiteDatabase bd2 = BaseDeDatos.getWritableDatabase();
        bd2.execSQL("INSERT INTO productos (nombre_p, mat_act, tipo_fit, fabricante, observacion, n_registro) VALUES ('"+fito.getNombre()+
                "', '"+fito.getMateria()+ "', "+fito.getTipo()+", '','', 0)");
        bd2.close();
        id = getProductoComercial(fito);

        return id;
    }

    public static int getTipoTareaT(int tarea){
        int id = -1;
        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT tipo_t FROM tareas WHERE tareas_id = " + tarea, null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }
        c.close();
        bd.close();


        return id;
    }
    public static int getAbono(Abonado fito){
        int id=-1;

        SQLiteDatabase bd = BaseDeDatos.getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * FROM abonos WHERE nombre_a = '" + fito.getNombre()+"'", null);
        if(c.moveToNext()){
            id=c.getInt(0);
        }else{
            id = newAbono(fito);
        }
        c.close();
        bd.close();


        return id;
    }
    public static int newAbono(Abonado fito){
        int id = -1;

        SQLiteDatabase bd2 = BaseDeDatos.getWritableDatabase();
        bd2.execSQL("INSERT INTO abonos (nombre_a,mat_act,uso,fabricante) VALUES ('"+fito.getNombre()+
                "', '', '', '' )");
        bd2.close();
        id = getAbono(fito);

        return id;
    }

}
