package com.example.ivan.ponsi;

import android.app.Activity;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.URLUtil;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;


public class EditarCliente extends ActionBarActivity {
    private long id;
    private boolean nuevo;
    private Button guard, cancel;
    private Cliente cliente = new Cliente();
    private EditText nombre,apellidos,alias,direccion,localidad,zip,provincia,pais,telefono,telefono2,email,dni;
    private Uri uriFoto = null;
    private String foto;
    private ImageView imageView;
    final static int RESULTADO_EDITAR = 1;
    final static int RESULTADO_GALERIA = 2;
    final static int RESULTADO_FOTO = 3;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.editar_propietario);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        nuevo = extras.getBoolean("nuevo", false);

        nombre = (EditText) findViewById(R.id.nombre_c);
        apellidos = (EditText) findViewById(R.id.apellidos_c);
        alias = (EditText) findViewById(R.id.alias_c);
        direccion = (EditText) findViewById(R.id.direccion_c);
        localidad = (EditText) findViewById(R.id.localidad_c);
        zip = (EditText) findViewById(R.id.zip_c);
        provincia = (EditText) findViewById(R.id.provincia_c);
        pais = (EditText) findViewById(R.id.pais_c);
        telefono = (EditText) findViewById(R.id.telefono_c);
        telefono2 = (EditText) findViewById(R.id.telefono2_c);
        email = (EditText) findViewById(R.id.email_c);
        dni = (EditText) findViewById(R.id.dni_c);
        imageView = (ImageView) findViewById(R.id.foto_c);



        if(!nuevo){
            //intrucciones que realizar si es ya esta creado el cliente

          rellenar();


        }


    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.edicion_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar:
               cancelar();
                return true;
            case R.id.accion_guardar:

               guardar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void guardar2(){
        cliente.setNombre("" + nombre.getText().toString());
        cliente.setApellidos("" + apellidos.getText().toString());
        cliente.setDireccion("" + direccion.getText().toString());
        cliente.setTelefono(Integer.parseInt(0 + telefono.getText().toString()));
        cliente.setTelefono2(Integer.parseInt(0 + telefono2.getText().toString()));
        cliente.setAlias("" + alias.getText().toString());
        cliente.setEmail("" + email.getText().toString());
        cliente.setDireccion("" + direccion.getText().toString());
        cliente.setDni("" + dni.getText().toString());
        cliente.setLocalidad("" + localidad.getText().toString());
        cliente.setZip("" + zip.getText().toString());
        cliente.setPais("" + pais.getText().toString());
        cliente.setProvincia("" + provincia.getText().toString());
        if (uriFoto != null){

            cliente.setFoto(uriFoto.toString());
        }


        ConsultaBD.actualizarCliente((int) id, cliente);

    }
    public void guardar(){
        cliente.setNombre("" + nombre.getText().toString());
        cliente.setApellidos("" + apellidos.getText().toString());
        cliente.setDireccion("" + direccion.getText().toString());
        cliente.setTelefono(Integer.parseInt(0 + telefono.getText().toString()));
        cliente.setTelefono2(Integer.parseInt(0 + telefono2.getText().toString()));
        cliente.setAlias("" + alias.getText().toString());
        cliente.setEmail("" + email.getText().toString());
        cliente.setDireccion("" + direccion.getText().toString());
        cliente.setDni("" + dni.getText().toString());
        cliente.setLocalidad("" + localidad.getText().toString());
        cliente.setZip("" + zip.getText().toString());
        cliente.setPais("" + pais.getText().toString());
        cliente.setProvincia("" + provincia.getText().toString());
        if (uriFoto != null){

            cliente.setFoto(uriFoto.toString());
        }


        ConsultaBD.actualizarCliente((int) id, cliente);
        finish();
    }
    public void cancelar(){

        if (getIntent().getExtras().getBoolean("nuevo", false)) {
            ConsultaBD.borrarCliente((int) id);
        }
        finish();
    }
    public void rellenar(){
        cliente = ConsultaBD.Cliente((int)id);

        nombre.setText(cliente.getNombre());
        apellidos.setText(cliente.getApellidos());
        alias.setText(cliente.getAlias());
        direccion.setText(cliente.getDireccion());
        if(cliente.getTelefono()!=0){
            telefono.setText(Integer.toString(cliente.getTelefono()));
        }
        if(cliente.getTelefono2()!=0){
            telefono2.setText(Integer.toString(cliente.getTelefono2()));
        }
        email.setText(cliente.getEmail());
        dni.setText(cliente.getDni());
        localidad.setText(cliente.getLocalidad());
        pais.setText(cliente.getPais());
        provincia.setText(cliente.getProvincia());
        zip.setText(cliente.getZip());

        ponerFoto(imageView,cliente.getFoto());
    }

    protected void ponerFoto(ImageView imageView, String uri) {
        if (URLUtil.isValidUrl(uri)) {
            Toast.makeText(EditarCliente.this, "uri "+uri, Toast.LENGTH_LONG).show();
        imageView.setImageURI(Uri.parse(uri));
    } else {
            imageView.setImageResource(R.drawable.perfil);
        }
    }

    public void galeria(View view) {
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.addCategory(Intent.CATEGORY_OPENABLE);
        intent.setType("image/*");
        startActivityForResult(intent, RESULTADO_GALERIA);
    }

    public void tomarFoto(View view) {
        Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
        uriFoto = Uri.fromFile(new File(
                Environment.getExternalStorageDirectory() + File.separator
                        + "img_" + (System.currentTimeMillis() / 1000) + ".jpg"));
        intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFoto);
        startActivityForResult(intent, RESULTADO_FOTO);
    }

    public void eliminarFoto(View view) {
        final TextView entrada = new TextView(this);
        new AlertDialog.Builder(this)
                .setTitle("@sting/del_photo")
                .setMessage("¿Esta seguro que quiere eliminar la imagen del propietario?")
                .setView(entrada)
                .setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        cliente.setFoto(null);
                        ponerFoto(imageView, null);
                    }
                })
                .setNegativeButton("Cancelar", null)
                .show();

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == RESULTADO_EDITAR) {


        } else if (requestCode == RESULTADO_GALERIA && resultCode == Activity.RESULT_OK) {
            cliente.setFoto(data.getDataString());

            ponerFoto(imageView, cliente.getFoto());
        } else if (requestCode == RESULTADO_FOTO && resultCode == Activity.RESULT_OK
                && cliente!=null && uriFoto!=null) {
            cliente.setFoto(uriFoto.toString());
            ponerFoto(imageView, cliente.getFoto());
        }
    }

    /*@Override
    protected  void onSaveInstanceState(Bundle guardarEstado){
        super.onSaveInstanceState(guardarEstado);
        guardar2();
        guardarEstado.putLong("identificador",id);

    }

    @Override
    protected void onRestoreInstanceState(Bundle recEstado){
        super.onRestoreInstanceState(recEstado);
        rellenar();

    }*/

    @Override
    public void onBackPressed() {


        new AlertDialog.Builder(this)
                .setTitle("Salir del editor")
                .setMessage("¿Esta seguro que quiere salir sin guardar? todos los cambios se perderan")
                        //.setView(entrada)
                .setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        guardar();
                    }
                })
                .setNegativeButton("Salir", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                cancelar();
                            }
                        }

                )
                .

                        show();

    }

}
