package com.example.ivan.ponsi;

import android.app.Activity;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.URLUtil;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;

import java.io.File;

/**
 * Created by Ivan on 19/10/2015.
 */
public class EditarParcela extends ActionBarActivity {
    private long id;
    private boolean nuevo;
    private Spinner tipoSuperficie;
    private EditText finca,localidad,provincia,paraje,poligono,parcela,superficie,cultivo;
    private Uri uriFoto = null;
    private String foto;
    private ImageView imageView;
    private Parcela place = new Parcela();
    final static int RESULTADO_EDITAR = 1;
    final static int RESULTADO_GALERIA = 2;
    final static int RESULTADO_FOTO = 3;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_parcela);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        nuevo = extras.getBoolean("nuevo", false);

        //creo he inicializo el spinner
        tipoSuperficie = (Spinner) findViewById(R.id.super_ed);
        ArrayAdapter<String> adaptador2 = new ArrayAdapter<String>(this,
                android.R.layout.simple_spinner_item, ConsultaBD.getSuperficies());
        adaptador2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        tipoSuperficie.setAdapter(adaptador2);
        if(nuevo){tipoSuperficie.setSelection(0);}

        //Referencio los editext
        finca = (EditText) findViewById(R.id.finca_e_p);
        localidad = (EditText) findViewById(R.id.localidad_e_p);
        provincia = (EditText) findViewById(R.id.provincia_e_p);
        paraje = (EditText) findViewById(R.id.paraje_e_p);
        poligono = (EditText) findViewById(R.id.poligono_e_p);
        parcela = (EditText) findViewById(R.id.parcela_e_p);
        superficie = (EditText) findViewById(R.id.superficie_e_p);
        cultivo = (EditText) findViewById(R.id.cultivo_e_p);
        imageView = (ImageView)findViewById(R.id.imageView_e_p);

        if(!nuevo){
            //Si no es una ficha nueva cargo los valores que ya tenia
           rellenar();
        }


    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.edicion_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar:
                cancelar();
                return true;
            case R.id.accion_guardar:

                guardar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void guardar2(){
        place.setParaje("" + paraje.getText().toString());
        place.setParcela(Integer.parseInt(0 + parcela.getText().toString()));
        place.setPoligono(Integer.parseInt(0 + poligono.getText().toString()));
        place.setSuperficie(Float.parseFloat(0 + superficie.getText().toString()));
        place.setPoble("" + localidad.getText().toString());
        place.setFinca("" + finca.getText().toString());
        place.setCultivo("" + cultivo.getText().toString());
        place.settSuperficie(tipoSuperficie.getSelectedItemPosition());
        place.setProvincia("" + provincia.getText().toString());

        if (uriFoto != null){

            place.setFoto(uriFoto.toString());
        }

        ConsultaBD.actulizarParcela((int) id, place);


    }
    public void guardar(){
        place.setParaje("" + paraje.getText().toString());
        place.setParcela(Integer.parseInt(0 + parcela.getText().toString()));
        place.setPoligono(Integer.parseInt(0 + poligono.getText().toString()));
        place.setSuperficie(Float.parseFloat(0 + superficie.getText().toString()));
        place.setPoble("" + localidad.getText().toString());
        place.setFinca("" + finca.getText().toString());
        place.setCultivo("" + cultivo.getText().toString());
        place.settSuperficie(tipoSuperficie.getSelectedItemPosition());
        place.setProvincia("" + provincia.getText().toString());

        if (uriFoto != null){

            place.setFoto(uriFoto.toString());
        }

        ConsultaBD.actulizarParcela((int) id, place);
        finish();

    }
    public void cancelar(){
        //Toast.makeText(EditarCliente.this, "id =" + id, Toast.LENGTH_LONG).show();
        if (getIntent().getExtras().getBoolean("nuevo", false)) {
        ConsultaBD.borrarParaje((int) id);
         }
        finish();
    }
    public void rellenar(){
        place = ConsultaBD.Parcela((int)id);

        finca.setText( place.getFinca());
        localidad.setText( place.getPoble());
        provincia.setText(place.getProvincia());
        paraje.setText(place.getParaje());
        if(place.getPoligono()!=0){
            poligono.setText(Integer.toString(place.getPoligono()));
        }
        if(place.getParcela()!=0){
            parcela.setText(Integer.toString(place.getParcela()));
        }
        if(place.getSuperficie()!=0){
            superficie.setText(Float.toString(place.getSuperficie()));
        }
        cultivo.setText(place.getCultivo());
        ponerFoto(imageView, place.getFoto());
    }

    protected void ponerFoto(ImageView imageView, String uri) {

        if (URLUtil.isValidUrl(uri)) {

            imageView.setImageURI(Uri.parse(uri));
        } else {
            imageView.setImageResource(R.drawable.campo);
        }
    }

    public void galeria(View view) {
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.addCategory(Intent.CATEGORY_OPENABLE);
        intent.setType("image/*");
        startActivityForResult(intent, RESULTADO_GALERIA);
    }

    public void tomarFoto(View view) {
        Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
        uriFoto = Uri.fromFile(new File(
                Environment.getExternalStorageDirectory() + File.separator
                        + "img_" + (System.currentTimeMillis() / 1000) + ".jpg"));
        intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFoto);
        startActivityForResult(intent, RESULTADO_FOTO);
    }

    public void eliminarFoto(View view) {
        final TextView entrada = new TextView(this);
        new AlertDialog.Builder(this)
                .setTitle("@sting/del_photo")
                .setMessage("¿Esta seguro que quiere eliminar la imagen del propietario?")
                .setView(entrada)
                .setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        place.setFoto(null);
                        ponerFoto(imageView, null);
                    }
                })
                .setNegativeButton("Cancelar", null)
                .show();

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == RESULTADO_EDITAR) {


        } else if (requestCode == RESULTADO_GALERIA && resultCode == Activity.RESULT_OK) {
            place.setFoto(data.getDataString());

            ponerFoto(imageView, place.getFoto());
        } else if (requestCode == RESULTADO_FOTO && resultCode == Activity.RESULT_OK
                && place!=null && uriFoto!=null) {
            place.setFoto(uriFoto.toString());
            ponerFoto(imageView, place.getFoto());
        }
    }

    @Override
    protected  void onSaveInstanceState(Bundle guardarEstado){
        super.onSaveInstanceState(guardarEstado);
        guardar2();
        guardarEstado.putLong("identificador", id);

    }

    @Override
    protected void onRestoreInstanceState(Bundle recEstado){
        super.onRestoreInstanceState(recEstado);
        rellenar();

    }

    @Override
    public void onBackPressed() {


        new AlertDialog.Builder(this)
                .setTitle("Salir del editor")
                .setMessage("¿Esta seguro que quiere salir sin guardar? todos los cambios se perderan")
                        //.setView(entrada)
                .setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        guardar();
                    }
                })
                .setNegativeButton("Salir", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                cancelar();
                            }
                        }

                )
                .

                        show();

    }
}
