package com.example.ivan.ponsi;

import android.app.Activity;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.URLUtil;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;


public class EditarProducto extends ActionBarActivity {
    private long id;
    private boolean nuevo=false;
    private boolean nuevo2=false;
    private Producto producto = new Producto();

    private EditText nombre,fabricante,registro,materia,observaciones;
    private Spinner tipo;
    private Uri uriFoto = null;

    private ImageView imageView;
    final static int RESULTADO_EDITAR = 1;
    final static int RESULTADO_GALERIA = 2;
    final static int RESULTADO_FOTO = 3;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_producto);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        nuevo = extras.getBoolean("nuevo", false);

        nombre = (EditText) findViewById(R.id.nombre_comercial);
        fabricante = (EditText) findViewById(R.id.fabricante);
        registro = (EditText) findViewById(R.id.registro);
        materia = (EditText) findViewById(R.id.materia_activa);
        observaciones = (EditText) findViewById(R.id.observaciones);
        imageView = (ImageView) findViewById(R.id.foto_f_c);
        tipo = (Spinner)findViewById(R.id.tipo_fito);



        if(!nuevo){
            //intrucciones que realizar si es ya esta creado el producto

           rellenar();


        }


    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.edicion_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar:
               cancelar();
                return true;
            case R.id.accion_guardar:

               guardar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void guardar2(){
        producto.setNombre("" + nombre.getText().toString());
        producto.setFabricante("" + fabricante.getText().toString());
        producto.setRegistro(Integer.parseInt(0+registro.getText().toString()));
        producto.setTipo(tipo.getSelectedItemPosition());
        producto.setMateria(""+materia.getText().toString());
        producto.setObservaciones(""+observaciones.getText().toString());

        if (uriFoto != null){

            producto.setFoto(uriFoto.toString());
        }


        if(nuevo){
            id = ConsultaBD.nuevoProducto(producto);
            nuevo=false;
            nuevo2=true;
        }else{
            ConsultaBD.actualizarProducto((int) id, producto);
        }

    }
    public void guardar(){
        producto.setNombre("" + nombre.getText().toString());
        producto.setFabricante("" + fabricante.getText().toString());
        producto.setRegistro(Integer.parseInt(0+registro.getText().toString()));
        producto.setTipo(tipo.getSelectedItemPosition());
        producto.setMateria(""+materia.getText().toString());
        producto.setObservaciones(""+observaciones.getText().toString());

        if (uriFoto != null){

            producto.setFoto(uriFoto.toString());
        }


        if(nuevo){
            id=ConsultaBD.nuevoProducto(producto);
        }else{
            ConsultaBD.actualizarProducto((int) id, producto);
        }
        finish();
    }
    public void cancelar(){
        if(nuevo2){
            ConsultaBD.borrarProducto((int) id);
        }
        finish();
    }

    public void rellenar(){
        producto = ConsultaBD.Producto((int) id);

        nombre.setText(""+producto.getNombre());
        fabricante.setText(""+producto.getFabricante());
        if(producto.getRegistro()!=0){
        registro.setText("" + producto.getRegistro());
        }
        materia.setText(""+producto.getMateria());
        if(!producto.getObservaciones().equals("")){
            observaciones.setHint("");
        }
        observaciones.setText("" + producto.getObservaciones());
        tipo.setSelection(producto.getTipo());

        ponerFoto(imageView, producto.getFoto());
    }

    protected void ponerFoto(ImageView imageView, String uri) {
        if (URLUtil.isValidUrl(uri)) {

        imageView.setImageURI(Uri.parse(uri));
    } else {
            switch (producto.getTipo()){
                case 0:
                    imageView.setImageResource(R.drawable.insecticida);
                    break;
                case 1:
                    imageView.setImageResource(R.drawable.herbicida);
                    break;
                case 2:
                    imageView.setImageResource(R.drawable.fitoreguladores);
                    break;
                case 3:
                    imageView.setImageResource(R.drawable.otros_fito);
                    break;
            }

        }
    }

    public void galeria(View view) {
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.addCategory(Intent.CATEGORY_OPENABLE);
        intent.setType("image/*");
        startActivityForResult(intent, RESULTADO_GALERIA);
    }

    public void tomarFoto(View view) {
        Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
        uriFoto = Uri.fromFile(new File(
                Environment.getExternalStorageDirectory() + File.separator
                        + "img_" + (System.currentTimeMillis() / 1000) + ".jpg"));
        intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFoto);
        startActivityForResult(intent, RESULTADO_FOTO);
    }

    public void eliminarFoto(View view) {
        final TextView entrada = new TextView(this);
        new AlertDialog.Builder(this)
                .setTitle("@sting/del_photo")
                .setMessage("¿Esta seguro que quiere eliminar la imagen del producto?")
                .setView(entrada)
                .setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        producto.setFoto(null);
                        ponerFoto(imageView, null);
                    }
                })
                .setNegativeButton("Cancelar", null)
                .show();

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == RESULTADO_EDITAR) {


        } else if (requestCode == RESULTADO_GALERIA && resultCode == Activity.RESULT_OK) {
            producto.setFoto(data.getDataString());

            ponerFoto(imageView, producto.getFoto());
        } else if (requestCode == RESULTADO_FOTO && resultCode == Activity.RESULT_OK
                && producto!=null && uriFoto!=null) {
            producto.setFoto(uriFoto.toString());
            ponerFoto(imageView, producto.getFoto());
        }
    }

    /*@Override
    protected  void onSaveInstanceState(Bundle guardarEstado){
        super.onSaveInstanceState(guardarEstado);
        guardar2();
        guardarEstado.putLong("identificador", id);
        guardarEstado.putBoolean("nuevo",nuevo2);

    }

    @Override
    protected void onRestoreInstanceState(Bundle recEstado){
        super.onRestoreInstanceState(recEstado);
        id = recEstado.getLong("identificador",-1);
        nuevo2 = recEstado.getBoolean("nuevo",nuevo2);
        rellenar();

    }*/

    @Override
    public void onBackPressed() {


        new AlertDialog.Builder(this)
                .setTitle("Salir del editor")
                .setMessage("¿Esta seguro que quiere salir sin guardar? todos los cambios se perderan")
                        //.setView(entrada)
                .setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        guardar();
                    }
                })
                .setNegativeButton("Salir", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                cancelar();
                            }
                        }

                )
                .

                        show();

    }

}
