package com.example.ivan.ponsi;

import android.app.DatePickerDialog;
import android.content.DialogInterface;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

/**
 * Created by Ivan on 26/10/2015.
 */
public class EditarTareaAbono extends AppCompatActivity implements  DatePickerDialog.OnDateSetListener{
    private ViewGroup layout;
    LinearLayout nuevoLayout;
    TextView nom,alias,paraje,finca, identificador, fecha, fecha_n;
    EditText titulo,observaciones,tiempo,coste;
    Spinner s_dosis, s_tiempo;
    EditText motivo,nom_comer,cantidad,dosis;
    long id, idf;
    //int idp, idtt;
    boolean nuevo;
    private Tarea tarea = new Tarea();
    private Abonado fito = new Abonado();
    private ArrayList<Integer> borrar_abo = new ArrayList<>();


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_tarea_abono_sol);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);  //id es el identificador de la tabla tares
        nuevo = extras.getBoolean("nuevo", false);
        //idp = extras.getInt("idp", -1);
        //idtt = extras.getInt("idtt", -1);

        layout = (ViewGroup) findViewById(R.id.l_abono_sol);

        //Referencio los editext y TextView estaticos
        nom = (TextView) findViewById(R.id.nom_f_t);
        alias = (TextView) findViewById(R.id.alias_f_t);
        paraje = (TextView) findViewById(R.id.paraje_f_t);
        finca = (TextView) findViewById(R.id.finca_f_t);
        titulo = (EditText) findViewById(R.id.titulo_f_t);
        fecha = (TextView) findViewById(R.id.fecha_num);
        fecha_n = (TextView) findViewById(R.id.fecha_f_t);
        observaciones = (EditText) findViewById(R.id.observaciones_f_t);
        tiempo = (EditText) findViewById(R.id.tiempo_f_t);
        coste = (EditText) findViewById(R.id.coste_f_t);
        s_tiempo = (Spinner) findViewById(R.id.stiempo_f_t);

        if(!nuevo){
            rellenarvista();
        }else{
            rellenarcabecera();
        }




    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.edicion_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar:
                cancelar();
                return true;
            case R.id.accion_guardar:

                guardar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void esNuevo(View view){
        LayoutInflater inflater = LayoutInflater.from(this);

        nuevoLayout = (LinearLayout) inflater.inflate(R.layout.abono_solido, null, false);

        layout.addView(nuevoLayout);
    }
    public void esQuitar(View view){
       if(!nuevo){
           View vista = (View) view.getParent();
           identificador = (TextView) vista.findViewById(R.id.ida);
           idf = Integer.parseInt(identificador.getText().toString());
           borrar_abo.add((int) idf);

       }
        layout.removeView((View) view.getParent());
    }

    public void cancelar(){

        if (getIntent().getExtras().getBoolean("nuevo", false)) {
            ConsultaBD.borrarTarea((int) id);
        }
        finish();
    }

    public void guardar() {
        tarea.setTitulo("" + titulo.getText().toString());
        if(tarea.getFecha()!=0){
            fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
        }
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setTiempo(Float.parseFloat(0 + tiempo.getText().toString()));
        tarea.setCoste(Float.parseFloat(0 + coste.getText().toString()));
        tarea.setsTiempo(s_tiempo.getSelectedItemPosition());

        //borro de la base de datos los  abonos que e eliminado
        for(Integer i: borrar_abo){
            ConsultaBD.borrarAbonado(i);
        }

        for (int i = 0, count = layout.getChildCount(); i < count; ++i) {
            View view = layout.getChildAt(i);

            //Referencio los editext del layout dinamico
            motivo = (EditText) view.findViewById(R.id.motivo_abo);
            nom_comer = (EditText) view.findViewById(R.id.nombre_abo);
            cantidad = (EditText) view.findViewById(R.id.cantidad_abo);
            dosis = (EditText) view.findViewById(R.id.dosis_abo);
            s_dosis = (Spinner) view.findViewById(R.id.s_dosis_a);
            identificador = (TextView) view.findViewById(R.id.ida);

            //Recojo los valores introducidos
            fito.setMotivo("" + motivo.getText().toString());
            fito.setNombre("" + nom_comer.getText().toString());
            fito.setCantidad(Double.parseDouble(0 + cantidad.getText().toString()));
            fito.setDosis(Double.parseDouble(0 + dosis.getText().toString()));
            fito.setsDosis(s_dosis.getSelectedItemPosition());


            //Guardo los valores en la base de datos
            idf = Integer.parseInt(0+identificador.getText().toString());
            if(idf==0){
                ConsultaBD.nuevoAbonado((int)id,fito);//nueva ficha
             }else{

                ConsultaBD.actualiarAbonado((int) idf, fito);
            }





        }

        ConsultaBD.actualizarTarea((int)id,tarea);

        finish();
    }
    public void guardar2() {
        tarea.setTitulo("" + titulo.getText().toString());
        if(tarea.getFecha()!=0){
            fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
        }
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setTiempo(Float.parseFloat(0 + tiempo.getText().toString()));
        tarea.setCoste(Float.parseFloat(0 + coste.getText().toString()));
        tarea.setsTiempo(s_tiempo.getSelectedItemPosition());

        //borro de la base de datos los  abonos que e eliminado
        for(Integer i: borrar_abo){
            ConsultaBD.borrarAbonado(i);
        }

        for (int i = 0, count = layout.getChildCount(); i < count; ++i) {
            View view = layout.getChildAt(i);

            //Referencio los editext del layout dinamico
            motivo = (EditText) view.findViewById(R.id.motivo_abo);
            nom_comer = (EditText) view.findViewById(R.id.nombre_abo);
            cantidad = (EditText) view.findViewById(R.id.cantidad_abo);
            dosis = (EditText) view.findViewById(R.id.dosis_abo);
            s_dosis = (Spinner) view.findViewById(R.id.s_dosis_a);
            identificador = (TextView) view.findViewById(R.id.ida);

            //Recojo los valores introducidos
            fito.setMotivo("" + motivo.getText().toString());
            fito.setNombre("" + nom_comer.getText().toString());
            fito.setCantidad(Double.parseDouble(0 + cantidad.getText().toString()));
            fito.setDosis(Double.parseDouble(0 + dosis.getText().toString()));
            fito.setsDosis(s_dosis.getSelectedItemPosition());


            //Guardo los valores en la base de datos
            idf = Integer.parseInt(0+identificador.getText().toString());
            if(idf==0){
                ConsultaBD.nuevoAbonado((int)id,fito);//nueva ficha
            }else{

                ConsultaBD.actualiarAbonado((int) idf, fito);
            }





        }

        ConsultaBD.actualizarTarea((int) id, tarea);


    }

    public void rellenarcabecera(){

        tarea = ConsultaBD.TareaVacia((int) id);

        if(tarea != null) {

            nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
            finca.setText(tarea.getFinca());
        }
    }

    public void rellenarvista(){

        tarea = ConsultaBD.Tarea((int) id);

        if(tarea != null){

             nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
             finca.setText(tarea.getFinca());
            titulo.setText(tarea.getTitulo());
            if(tarea.getFecha()!=0){
                fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
                fecha_n.setText(Float.toString(tarea.getFecha()));
            }
            observaciones.setText(tarea.getObservaciones());
            if(tarea.getTiempo()!=0){
                tiempo.setText(Double.toString(tarea.getTiempo()));
            }
            if(tarea.getCoste()!=0){
                coste.setText(Double.toString(tarea.getCoste()));
            }
            s_tiempo.setSelection(tarea.getsTiempo());

        }

        Cursor c = ConsultaBD.listadoAbonado((int)id);

        while(c.moveToNext()){
            //Creo el layout
            LayoutInflater inflater = LayoutInflater.from(this);
            nuevoLayout = (LinearLayout) inflater.inflate(R.layout.abono_solido, null, false);

            //Referencio los textview
            motivo = (EditText) nuevoLayout.findViewById(R.id.motivo_abo);
            nom_comer = (EditText) nuevoLayout.findViewById(R.id.nombre_abo);
            cantidad = (EditText) nuevoLayout.findViewById(R.id.cantidad_abo);
            dosis = (EditText) nuevoLayout.findViewById(R.id.dosis_abo);
            s_dosis = (Spinner) nuevoLayout.findViewById(R.id.s_dosis_a);
            identificador = (TextView) nuevoLayout.findViewById(R.id.ida);

            //Pongo el texto en los TextView
            Double valor;
            identificador.setText(Integer.toString(c.getInt(c.getColumnIndex("abonado_id"))));
            motivo.setText(c.getString(c.getColumnIndex("motivo")));
            nom_comer.setText(c.getString(c.getColumnIndex("nombre_a")));
            valor=c.getDouble(c.getColumnIndex("cantidad"));
            if(valor!=0){
                cantidad.setText(Double.toString(valor));
            }
            valor =c.getDouble(c.getColumnIndex("dosis"));
            if(valor!=0){
                dosis.setText(Double.toString(valor));
            }
            s_dosis.setSelection(c.getInt(c.getColumnIndex("dosis_s")));

            //Añado el Layout a la vista
            layout.addView(nuevoLayout);


        }

    }

    public void elegirFecha(View view){
        fecha =(TextView) view.findViewById(R.id.fecha_f_t);
        fecha_n = (TextView)view.findViewById(R.id.fecha_num);
        DatePickerFragment newFragment = new DatePickerFragment();
        newFragment.setEscuchador(this);
        newFragment.show(getSupportFragmentManager(), "Elegir fecha");

    }

    public void onDateSet(DatePicker view, int year, int month, int day) {
        // Do something with the date chosen by the user
        Calendar calendario = Calendar.getInstance();
        calendario.set(year, month, day);
        long valor = calendario.getTimeInMillis();
        mostrarfecha(valor);

    }
    public void mostrarfecha(long num){

        fecha.setText(DateFormat.getDateInstance().format(new Date(num)));
        fecha_n.setText(Long.toString(num));

    }

    @Override
    protected  void onSaveInstanceState(Bundle guardarEstado){
        super.onSaveInstanceState(guardarEstado);
        guardar2();
        guardarEstado.putLong("identificador", id);

    }

    @Override
    protected void onRestoreInstanceState(Bundle recEstado){
        super.onRestoreInstanceState(recEstado);
        rellenarvista();

    }
    @Override
    public void onBackPressed() {


        new AlertDialog.Builder(this)
                .setTitle("Salir del editor")
                .setMessage("¿Esta seguro que quiere salir sin guardar? todos los cambios se perderan")
                        //.setView(entrada)
                .setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        guardar();
                    }
                })
                .setNegativeButton("Salir", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                cancelar();
                            }
                        }

                )
                .

                        show();

    }

}
