package com.example.ivan.ponsi;

import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.content.DialogInterface;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * Created by Ivan on 26/10/2015.
 */
public class EditarTareaOtros extends AppCompatActivity implements  DatePickerDialog.OnDateSetListener{

    TextView nom,alias,paraje,finca, identificador, fecha, fecha_n;
    EditText titulo,observaciones,tiempo,coste;
    Spinner s_tiempo;
    EditText realizado;
    long id, idf;
    //int idp, idtt;
    boolean nuevo;
    private Tarea tarea = new Tarea();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_tarea_otros);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);  //id es el identificador de la tabla tares
        nuevo = extras.getBoolean("nuevo", false);
        //idp = extras.getInt("idp", -1);
        //idtt = extras.getInt("idtt", -1);



        //Referencio los editext y TextView estaticos
        nom = (TextView) findViewById(R.id.nom_f_t);
        alias = (TextView) findViewById(R.id.alias_f_t);
        paraje = (TextView) findViewById(R.id.paraje_f_t);
        finca = (TextView) findViewById(R.id.finca_f_t);
        titulo = (EditText) findViewById(R.id.titulo_f_t);
        fecha = (TextView) findViewById(R.id.fecha_f_t);
        fecha_n = (TextView) findViewById(R.id.fecha_num);
        observaciones = (EditText) findViewById(R.id.observaciones_f_t);
        tiempo = (EditText) findViewById(R.id.tiempo_f_t);
        coste = (EditText) findViewById(R.id.coste_f_t);
        s_tiempo = (Spinner) findViewById(R.id.stiempo_f_t);
        realizado = (EditText) findViewById(R.id.tarea_realizada_f_t);

        if(!nuevo){
            rellenarvista();
        }else{
            rellenarcabecera();
        }




    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.edicion_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar:
                cancelar();
                return true;
            case R.id.accion_guardar:

                guardar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }



    public void cancelar(){

        if (getIntent().getExtras().getBoolean("nuevo", false)) {
            ConsultaBD.borrarTarea((int) id);
        }
        finish();
    }

    public void guardar2() {
        String realizada;
        tarea.setTitulo("" + titulo.getText().toString());
        tarea.setFecha(Float.parseFloat(0 + fecha_n.getText().toString()));
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setTiempo(Float.parseFloat(0 + tiempo.getText().toString()));
        tarea.setCoste(Float.parseFloat(0 + coste.getText().toString()));
        tarea.setsTiempo(s_tiempo.getSelectedItemPosition());

        realizada = realizado.getText().toString();
        if(nuevo){
        ConsultaBD.nuevoOtros((int)id, realizada);
        }else{
            ConsultaBD.actualizarOtros((int) id, realizada);
        }


        ConsultaBD.actualizarTarea((int) id, tarea);


    }
    public void guardar() {
        String realizada;
        tarea.setTitulo("" + titulo.getText().toString());
        tarea.setFecha(Float.parseFloat(0 + fecha_n.getText().toString()));
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setTiempo(Float.parseFloat(0 + tiempo.getText().toString()));
        tarea.setCoste(Float.parseFloat(0 + coste.getText().toString()));
        tarea.setsTiempo(s_tiempo.getSelectedItemPosition());

        realizada = realizado.getText().toString();
        if(nuevo){
            ConsultaBD.nuevoOtros((int)id, realizada);
        }else{
            ConsultaBD.actualizarOtros((int) id, realizada);
        }


        ConsultaBD.actualizarTarea((int)id,tarea);

        finish();
    }

    public void rellenarcabecera(){

        tarea = ConsultaBD.TareaVacia((int)id);

        if(tarea != null) {

            nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
            finca.setText(tarea.getFinca());
        }
    }

    public void rellenarvista(){

        tarea = ConsultaBD.Tarea((int) id);

        if(tarea != null){

             nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
             finca.setText(tarea.getFinca());
            titulo.setText(tarea.getTitulo());
            if(tarea.getFecha()!=0){
                fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
                fecha_n.setText(Float.toString(tarea.getFecha()));
            }
            observaciones.setText(tarea.getObservaciones());
            if(tarea.getTiempo()!=0){
                tiempo.setText(Double.toString(tarea.getTiempo()));
            }
            if(tarea.getCoste()!=0){
                coste.setText(Double.toString(tarea.getCoste()));
            }
            s_tiempo.setSelection(tarea.getsTiempo());

        }

        Cursor c = ConsultaBD.listadoOtros((int) id);

        if(c.moveToNext()){

            identificador = (TextView) findViewById(R.id.ido);

            //Pongo el texto en los TextView
            identificador.setText(Integer.toString(c.getInt(c.getColumnIndex("otros_id"))));
            realizado.setText(c.getString((c.getColumnIndex("realizado"))));


        }

    }

    public void elegirFecha(View view){
        fecha =(TextView) view.findViewById(R.id.fecha_f_t);
        fecha_n = (TextView)view.findViewById(R.id.fecha_num);
        DatePickerFragment newFragment = new DatePickerFragment();
        newFragment.setEscuchador(this);
        newFragment.show(getSupportFragmentManager(), "Elegir fecha");

    }

    public void onDateSet(DatePicker view, int year, int month, int day) {
        // Do something with the date chosen by the user
        Calendar calendario = Calendar.getInstance();
        calendario.set(year, month, day);
        long valor = calendario.getTimeInMillis();
        mostrarfecha(valor);

    }
    public void mostrarfecha(long num){


        fecha.setText(DateFormat.getDateInstance().format(new Date(num)));
        fecha_n.setText(Long.toString(num));

    }

    @Override
    protected  void onSaveInstanceState(Bundle guardarEstado){
        super.onSaveInstanceState(guardarEstado);
        guardar2();
        guardarEstado.putLong("identificador", id);

    }

    @Override
    protected void onRestoreInstanceState(Bundle recEstado){
        super.onRestoreInstanceState(recEstado);
        rellenarvista();

    }
    @Override
    public void onBackPressed() {


        new AlertDialog.Builder(this)
                .setTitle("Salir del editor")
                .setMessage("¿Esta seguro que quiere salir sin guardar? todos los cambios se perderan")
                        //.setView(entrada)
                .setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        guardar();
                    }
                })
                .setNegativeButton("Salir", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                cancelar();
                            }
                        }

                )
                .

                        show();

    }
}
