package com.example.ivan.ponsi;

import android.app.DatePickerDialog;
import android.content.DialogInterface;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.RatingBar;
import android.widget.Spinner;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * Created by Ivan on 26/10/2015.
 */
public class EditarTareaPendiente extends AppCompatActivity implements  DatePickerDialog.OnDateSetListener{

    TextView nom,alias,paraje,finca, fecha, fecha_n;
    EditText titulo,observaciones;
    RatingBar prioridad;
    Spinner tipo;
    EditText realizado;
    long id;
    float val;

    boolean nuevo;
    private TareaPendiente tarea = new TareaPendiente();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_tarea_pendiente);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("idp", -1);  //id es el identificador de la tabla tares
        nuevo = extras.getBoolean("nuevo", false);
        //idp = extras.getInt("idp", -1);
        //idtt = extras.getInt("idtt", -1);



        //Referencio los editext y TextView estaticos
        nom = (TextView) findViewById(R.id.nom_f_t);
        alias = (TextView) findViewById(R.id.alias_f_t);
        paraje = (TextView) findViewById(R.id.paraje_f_t);
        finca = (TextView) findViewById(R.id.finca_f_t);
        titulo = (EditText) findViewById(R.id.titulo_f_t);
        fecha = (TextView) findViewById(R.id.fecha_f_t);
        fecha_n = (TextView) findViewById(R.id.fecha_num);
        observaciones = (EditText) findViewById(R.id.observaciones_f_t);
        prioridad = (RatingBar) findViewById(R.id.prioridad);
        realizado = (EditText) findViewById(R.id.tarea_realizada_f_t);
        tipo = (Spinner) findViewById(R.id.tipo_tarea_pen);
        prioridad.setRating(tarea.getPrioridad());
        prioridad.setOnRatingBarChangeListener(
                new RatingBar.OnRatingBarChangeListener() {
                    @Override
                    public void onRatingChanged(RatingBar ratingBar,
                                                float valor, boolean fromUser) {
                       val=valor;

                    }
                });

        if(!nuevo){
            rellenarvista();
        }else{
            rellenarcabecera();
        }




    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.edicion_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar:
                cancelar();
                return true;
            case R.id.accion_guardar:

                guardar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }



    public void cancelar(){

        if (getIntent().getExtras().getBoolean("nuevo", false)) {
            ConsultaBD.borrarTareaPendiente((int) id);
        }
        finish();
    }

    public void guardar() {
        TareaPendiente tarea = new TareaPendiente();
        tarea.setTitulo("" + titulo.getText().toString());
        tarea.setFecha(Float.parseFloat(0 + fecha_n.getText().toString()));
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setRealizada(realizado.getText().toString());
        tarea.setTipo(tipo.getSelectedItemPosition());
        tarea.setPrioridad(val);


        ConsultaBD.actualizarTareaPendiente((int)id,tarea);

        finish();
    }
    public void guardar2() {
        TareaPendiente tarea = new TareaPendiente();
        tarea.setTitulo("" + titulo.getText().toString());
        tarea.setFecha(Float.parseFloat(0 + fecha_n.getText().toString()));
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setRealizada(realizado.getText().toString());
        tarea.setTipo(tipo.getSelectedItemPosition());
        tarea.setPrioridad(val);


        ConsultaBD.actualizarTareaPendiente((int) id, tarea);


    }

    public void rellenarcabecera(){
        TareaPendiente tarea = new TareaPendiente();

        tarea = ConsultaBD.TareaPendienteVacia((int) id);

        if(tarea != null) {

            nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
            finca.setText(tarea.getFinca());
        }
    }

    public void rellenarvista(){
        TareaPendiente tarea = new TareaPendiente();

        tarea = ConsultaBD.TareaPendiente((int) id);

        if(tarea != null){

             nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
             finca.setText(tarea.getFinca());
            titulo.setText(tarea.getTitulo());
            if(tarea.getFecha()!=0){
                fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
                fecha_n.setText(Float.toString(tarea.getFecha()));
            }
            observaciones.setText(tarea.getObservaciones());
            realizado.setText(tarea.getRealizada());
            prioridad.setRating(tarea.getPrioridad());
            tipo.setSelection(tarea.getTipo());

        }



    }

    public void elegirFecha(View view){
        fecha =(TextView) view.findViewById(R.id.fecha_f_t);
        fecha_n = (TextView)view.findViewById(R.id.fecha_num);
        DatePickerFragment newFragment = new DatePickerFragment();
        newFragment.setEscuchador(this);
        newFragment.show(getSupportFragmentManager(), "Elegir fecha");

    }

    public void onDateSet(DatePicker view, int year, int month, int day) {
        // Do something with the date chosen by the user
        Calendar calendario = Calendar.getInstance();
        calendario.set(year, month, day);
        long valor = calendario.getTimeInMillis();
        mostrarfecha(valor);

    }
    public void mostrarfecha(long num){


        fecha.setText(DateFormat.getDateInstance().format(new Date(num)));
        fecha_n.setText(Long.toString(num));

    }

    @Override
    protected  void onSaveInstanceState(Bundle guardarEstado){
        super.onSaveInstanceState(guardarEstado);
        guardar2();
        guardarEstado.putLong("identificador", id);

    }

    @Override
    protected void onRestoreInstanceState(Bundle recEstado){
        super.onRestoreInstanceState(recEstado);
        rellenarvista();

    }
    @Override
    public void onBackPressed() {


        new AlertDialog.Builder(this)
                .setTitle("Salir del editor")
                .setMessage("¿Esta seguro que quiere salir sin guardar? todos los cambios se perderan")
                        //.setView(entrada)
                .setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        guardar();
                    }
                })
                .setNegativeButton("Salir", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                cancelar();
                            }
                        }

                )
                .

                        show();

    }
}
