package com.example.ivan.ponsi;

import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.URLUtil;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class FichaCliente extends ActionBarActivity implements AdapterView.OnItemClickListener{
    public AdaptadorParcelas adaptador;
    private Button nuevo;
    private long id;
    private Cliente cliente = new Cliente();
    private TextView nombre, apellidos, alias, direccion, localidad, zip, provincia, pais, telefono, telefono2, email, dni;
    private Uri uriFoto;
    private ImageView imageView;
    final static int RESULTADO_EDITAR = 1;
    final static int RESULTADO_GALERIA = 2;
    final static int RESULTADO_FOTO = 3;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //cargamos el layout
        setContentView(R.layout.ficha_propietario);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);


        //Referenciamos los text view
        nombre = (TextView) findViewById(R.id.nombre_f_c);
        apellidos = (TextView) findViewById(R.id.apellidos_f_c);
        alias = (TextView) findViewById(R.id.alias_f_c);
        direccion = (TextView) findViewById(R.id.direccion_f_c);
        localidad = (TextView) findViewById(R.id.localidad_f_c);
        zip = (TextView) findViewById(R.id.zip_f_c);
        provincia = (TextView) findViewById(R.id.provincia_f_c);
        pais = (TextView) findViewById(R.id.pais_f_c);
        telefono = (TextView) findViewById(R.id.telefono_f_c);
        telefono2 = (TextView) findViewById(R.id.telefono2_f_c);
        email = (TextView) findViewById(R.id.email_f_c);
        dni = (TextView) findViewById(R.id.dni_f_c);
        imageView = (ImageView) findViewById(R.id.foto_f_c);

        //Actualizamos la vista
        actualizarcliente();

        //Lanzamos el list view
        listaparcelas();



        //Referenciamos y damos funcionalidad al boton de nueva parcela
        nuevo = (Button)findViewById(R.id.boton_nueva_parcela);
        nuevo.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                long id2 = ConsultaBD.nuevaParcela((int) id);
                Intent i = new Intent(FichaCliente.this, EditarParcela.class);
                i.putExtra("nuevo", true);
                i.putExtra("id", id2);
                startActivityForResult(i,0);
            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.ficha_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.informacion:
                Intent b = new Intent(this, InformacionCliente.class);
                startActivity(b);
                return true;



            case R.id.accion_editar:
                Intent i = new Intent(this, EditarCliente.class);
                i.putExtra("id", id);
                startActivityForResult(i, RESULTADO_EDITAR);

                return true;
            case R.id.accion_borrar:

                new AlertDialog.Builder(this)
                        .setTitle("Borrar ficha propietario?")
                        .setMessage("¿Seguro que quiere borrar este cliente?")
                        .setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                ConsultaBD.borrarCliente((int) id);
                                finish();
                            }
                        })
                        .setNegativeButton("Cancelar", null)
                        .show();

                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    private void actualizarcliente () {
        cliente = ConsultaBD.Cliente((int)id);


        if (cliente.getNombre().equals("")){
            View vista = (View) nombre.getParent();
            vista.setVisibility(View.INVISIBLE);
        }else{
            View vista = (View) nombre.getParent();
            vista.setVisibility(View.VISIBLE);
            nombre.setText(" "+cliente.getNombre());
        }
        if(cliente.getApellidos().equals("")){
            View vista = (View) apellidos.getParent();
            vista.setVisibility(View.INVISIBLE);
        }else{
            View vista = (View) apellidos.getParent();
            vista.setVisibility(View.VISIBLE);
            apellidos.setText(" "+cliente.getApellidos());
        }
        if(cliente.getAlias().equals("")){
            View vista = (View) alias.getParent();
            vista.setVisibility(View.INVISIBLE);
        }else{
            View vista = (View) alias.getParent();
            vista.setVisibility(View.VISIBLE);
            alias.setText(" "+cliente.getAlias());
        }
        if(cliente.getDireccion().equals("")){
            View vista = (View) direccion.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) direccion.getParent();
            vista.setVisibility(View.VISIBLE);
            direccion.setText(" " + cliente.getDireccion());
        }

        if(cliente.getTelefono()==0){
            View vista = (View) telefono.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) telefono.getParent();
            vista.setVisibility(View.VISIBLE);
            telefono.setText(" "+Integer.toString(cliente.getTelefono()));
        }
        if(cliente.getTelefono2()==0){
            View vista = (View) telefono2.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) telefono2.getParent();
            vista.setVisibility(View.VISIBLE);
            telefono2.setText(" " + Integer.toString(cliente.getTelefono2()));
        }
        if(cliente.getEmail().equals("")){
            View vista = (View) email.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) email.getParent();
            vista.setVisibility(View.VISIBLE);
            email.setText(" " + cliente.getEmail());
        }
        if(cliente.getDni().equals("")){
            View vista = (View) dni.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) dni.getParent();
            vista.setVisibility(View.VISIBLE);
            dni.setText(" " + cliente.getDni());
        }
        if(cliente.getLocalidad().equals("")){
            View vista = (View) localidad.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) localidad.getParent();
            vista.setVisibility(View.VISIBLE);
            localidad.setText(" " + cliente.getLocalidad());
        }
        if(cliente.getPais().equals("")){
            View vista = (View) pais.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) pais.getParent();
            vista.setVisibility(View.VISIBLE);
            pais.setText(" " + cliente.getPais());
        }
        if(cliente.getProvincia().equals("")){
            View vista = (View) provincia.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) provincia.getParent();
            vista.setVisibility(View.VISIBLE);
            provincia.setText(" " + cliente.getProvincia());
        }
        if(cliente.getZip().equals("")){
            View vista = (View) zip.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) zip.getParent();
            vista.setVisibility(View.VISIBLE);
            zip.setText(" " + cliente.getZip());
        }

        ponerFoto(imageView,cliente.getFoto());


    }
    protected void ponerFoto(ImageView imageView, String uri) {

        if (URLUtil.isValidUrl(uri)) {
            //Toast.makeText(FichaCliente.this, "uri "+uri, Toast.LENGTH_LONG).show();
            imageView.setImageURI(Uri.parse(uri));
        } else {
            imageView.setImageResource(R.drawable.perfil);
        }
    }

    //accion al pulsar el listview
    @Override
    public void onItemClick(AdapterView<?> parent, View vista,
                            int posicion, long id){
        Intent i = new Intent(this, FichaParcela.class);
        i.putExtra("id", id);
        startActivityForResult(i, 0); }


    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == RESULTADO_EDITAR) {
            actualizarcliente();


        }
        if (requestCode == 0) {

            listaparcelas();

        }
    }

    private void listaparcelas(){
        ConsultaBD.inicializaBD(this);
        adaptador = new AdaptadorParcelas(this, ConsultaBD.listadoParcelas((int)id));
        ListView listView = (ListView) findViewById(R.id.list_p);
        listView.setAdapter(adaptador);

        ElecPropietario.setListViewHeightBasedOnChildren(listView);//ajusta el tamaño de los elementos del listview

        listView.setOnItemClickListener(this);
    }

}