package com.example.ivan.ponsi;

import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.URLUtil;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import android.widget.Toast;

/**
 * Created by Ivan on 20/10/2015.
 */
public class FichaParcela extends AppCompatActivity implements AdapterView.OnItemClickListener {

    public  AdaptadorTareas adaptador;
    private Button nuevoR, nuevaT;
    private long id;
    private Parcela place = new Parcela();
    private TextView nombre, alias, localidad, provincia, finca, paraje, poligono, parcela, cultivo, superficie;
    private Uri uriFoto;
    private ImageView imageView;
    final static int RESULTADO_EDITAR = 1;



    @Override
    protected void onCreate(Bundle savedInstanceState) {

        //cargamos el layout
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ficha_parcela);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        //Toast.makeText(FichaParcela.this, "id =" + id, Toast.LENGTH_LONG).show();

        //Adaptador del ListView
        listatareas();


        //Referenciamos los text view
        nombre = (TextView) findViewById(R.id.nombre_f_p);
        alias = (TextView) findViewById(R.id.alias_f_p);
        finca = (TextView) findViewById(R.id.finca_f_p);
        localidad = (TextView) findViewById(R.id.localidad_f_p);
        provincia = (TextView) findViewById(R.id.provincia_f_p);
        paraje = (TextView) findViewById(R.id.paraje_f_p);
        poligono = (TextView) findViewById(R.id.poligono_f_p);
        parcela = (TextView) findViewById(R.id.parcela_f_p);
        superficie = (TextView) findViewById(R.id.superficie_f_p);
        cultivo = (TextView) findViewById(R.id.cultivo_f_p);
        imageView = (ImageView) findViewById(R.id.foto_f_p);

        //actualizamos la vista
        actulizaParcela();

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.ficha_parcela, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {

            case R.id.informacion:
                Intent b = new Intent(this, InformacionParcela.class);
                startActivity(b);
                return true;


            case R.id.accion_editar:
                Intent i = new Intent(this, EditarParcela.class);
                i.putExtra("id", id);
                startActivityForResult(i, RESULTADO_EDITAR);

                return true;
            case R.id.accion_borrar:

                new AlertDialog.Builder(this)
                        .setTitle("Borrar ficha propietario?")
                        .setMessage("¿Seguro que quiere borrar esta parcela?")
                        .setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                ConsultaBD.borrarParaje((int) id);
                                finish();
                            }
                        })
                        .setNegativeButton("Cancelar", null)
                        .show();

                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    private void actulizaParcela(){
        place = ConsultaBD.Parcela((int)id);

        if (place != null) {

            if (place.getPropietario().equals("")){
                View vista = (View) nombre.getParent();
                vista.setVisibility(View.INVISIBLE);
            }else{
                nombre.setText(" " + place.getPropietario());
            }
            if(place.getAlias().equals("")){
                View vista = (View) alias.getParent();
                vista.setVisibility(View.INVISIBLE);
            }else{
                alias.setText(" "+place.getAlias());
            }
            if(place.getFinca().equals("")){
                View vista = (View) finca.getParent();
                vista.setVisibility(View.INVISIBLE);
            }else{
                View vista = (View) finca.getParent();
                vista.setVisibility(View.VISIBLE);
                finca.setText(" "+ place.getFinca());
            }
            if(place.getPoble().equals("")){
                View vista = (View) localidad.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) localidad.getParent();
                vista.setVisibility(View.VISIBLE);
                localidad.setText(" "+ place.getPoble());
            }
            if(place.getProvincia().equals("")){
                View vista = (View) provincia.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) provincia.getParent();
                vista.setVisibility(View.VISIBLE);
                provincia.setText(" "+ place.getProvincia());
            }
            if(place.getParaje().equals("")){
                View vista = (View) paraje.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) paraje.getParent();
                vista.setVisibility(View.VISIBLE);
                paraje.setText(" "+place.getParaje());
            }
            if(place.getPoligono()==0){
                View vista = (View) poligono.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) poligono.getParent();
                vista.setVisibility(View.VISIBLE);
                poligono.setText(" "+ Integer.toString(place.getPoligono()));
            }
            if(place.getParcela()==0){
                View vista = (View) parcela.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) parcela.getParent();
                vista.setVisibility(View.VISIBLE);
                parcela.setText(" "+ Integer.toString(place.getParcela()));
            }
            if(place.getSuperficie()==0){
                View vista = (View) superficie.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) superficie.getParent();
                vista.setVisibility(View.VISIBLE);
                superficie.setText(" "+ Float.toString(place.getSuperficie())+" "+place.getTextsup());
            }
            if(place.getCultivo().equals("")){
                View vista = (View) cultivo.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) cultivo.getParent();
                vista.setVisibility(View.VISIBLE);
                cultivo.setText(" "+ place.getCultivo());
            }






            ponerFoto(imageView, place.getFoto());
        }else{Toast.makeText(FichaParcela.this, "Error en la conversion", Toast.LENGTH_LONG).show();}

    }

    protected void ponerFoto(ImageView imageView, String uri) {

        if (URLUtil.isValidUrl(uri)) {

            imageView.setImageURI(Uri.parse(uri));
        } else {
            imageView.setImageResource(R.drawable.campo);
        }
    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == RESULTADO_EDITAR) {
            actulizaParcela();

        }
        if (requestCode == 123) {

            listatareas();
        }
    }

    private void listatareas(){

        adaptador = new AdaptadorTareas(this, ConsultaBD.listadoTareas((int)id));
        ListView listView = (ListView) findViewById(R.id.list_t);
        listView.setAdapter(adaptador);

        ElecPropietario.setListViewHeightBasedOnChildren(listView);
        listView.setOnItemClickListener(this);
    }


    //Accion a realizar al pulsar el list view
    @Override
    public void onItemClick(AdapterView<?> parent, View vista,
                            int posicion, long id){


        int idtt = ConsultaBD.getTipoTareaT((int)id);


        switch (idtt){
            case 1:
                Intent i = new Intent(this, FichaTareaFito.class);
                i.putExtra("id", id);
                startActivityForResult(i, 123);
                break;
            case 2:
                Intent in = new Intent(this, FichaTareaOtros.class);
                in.putExtra("id", id);
                startActivityForResult(in, 123);
                break;
            case 3:
                Intent ab = new Intent(this, FichaTareaAbonado.class);
                ab.putExtra("id", id);
                startActivityForResult(ab, 123);
                break;
            case 4:
                Intent ag = new Intent(this, FichaTareaGoteo.class);
                ag.putExtra("id", id);
                startActivityForResult(ag, 123);
                break;
        }


    }


    public void elegirtipo(View view){

        Intent i = new Intent(this,ElegirTarea.class);
        i.putExtra("idp", id);
        startActivityForResult(i, 123);
    }

    public void nuevaTareaPendiente(View view){
        long id2 = ConsultaBD.nuevaTareaPendiente((int) id);
        Intent i = new Intent(this,EditarTareaPendiente.class);
        i.putExtra("idp", id2);
        i.putExtra("nuevo", true);
        startActivityForResult(i, 124);
    }




}
