package com.example.ivan.ponsi;

import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.URLUtil;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class FichaProducto extends ActionBarActivity {


    private long id;
    private TextView nombre,fabricante,registro,materia,observaciones;
    private TextView tipo;
    private Producto producto = new Producto();
    String[] tipos;

    private ImageView imageView;
    final static int RESULTADO_EDITAR = 1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //cargamos el layout
        setContentView(R.layout.ficha_producto);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);


        tipos = getResources().getStringArray(R.array.tipo_tratamiento);

        //Referenciamos los text view
        nombre = (TextView) findViewById(R.id.nombre_comercial);
        fabricante = (TextView) findViewById(R.id.fabricante);
        registro = (TextView) findViewById(R.id.registro);
        materia = (TextView) findViewById(R.id.materia_activa);
        observaciones = (TextView) findViewById(R.id.observaciones);
        imageView = (ImageView) findViewById(R.id.foto_f_c);
        tipo = (TextView)findViewById(R.id.tipo_fito);

        //Actualizamos la vista
        actualizarcliente();




    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.ficha_abono, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.informacion:
                Intent b = new Intent(this, InformacionProductos.class);
                startActivity(b);
                return true;


            case R.id.accion_editar:
                Intent i = new Intent(this, EditarProducto.class);
                i.putExtra("id", id);
                startActivityForResult(i, RESULTADO_EDITAR);

                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }

    private void actualizarcliente () {
        producto = ConsultaBD.Producto((int) id);

        if (producto.getNombre().equals("")){
            View vista = (View) nombre.getParent();
            vista.setVisibility(View.INVISIBLE);
        }else{
            View vista = (View) nombre.getParent();
            vista.setVisibility(View.VISIBLE);
            nombre.setText(" "+producto.getNombre());
        }
        if (producto.getFabricante().equals("")){
            View vista = (View) fabricante.getParent();
            vista.setVisibility(View.INVISIBLE);
        }else{
            View vista = (View) fabricante.getParent();
            vista.setVisibility(View.VISIBLE);
            fabricante.setText(" "+producto.getFabricante());
        }
        if (producto.getRegistro()==0){
            View vista = (View) registro.getParent();
            vista.setVisibility(View.INVISIBLE);
        }else{
            View vista = (View) registro.getParent();
            vista.setVisibility(View.VISIBLE);
            registro.setText(" "+producto.getRegistro());
        }
        if (producto.getMateria().equals("")){
            View vista = (View) materia.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) materia.getParent();
            vista.setVisibility(View.VISIBLE);
            materia.setText(" "+producto.getMateria());
        }
        if (producto.getObservaciones().equals("")){
            View vista = (View) observaciones.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) observaciones.getParent();
            vista.setVisibility(View.VISIBLE);
            observaciones.setText(" "+producto.getObservaciones());
        }

        tipo.setText(tipos[producto.getTipo()]);

        ponerFoto(imageView, producto.getFoto());


    }
    protected void ponerFoto(ImageView imageView, String uri) {

        if (URLUtil.isValidUrl(uri)) {
            //Toast.makeText(FichaCliente.this, "uri "+uri, Toast.LENGTH_LONG).show();
            imageView.setImageURI(Uri.parse(uri));
        } else {
            switch (producto.getTipo()){
                case 0:
                    imageView.setImageResource(R.drawable.insecticida);
                    break;
                case 1:
                    imageView.setImageResource(R.drawable.herbicida);
                    break;
                case 2:
                    imageView.setImageResource(R.drawable.fitoreguladores);
                    break;
                case 3:
                    imageView.setImageResource(R.drawable.otros_fito);
                    break;
            }
        }
    }




    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == RESULTADO_EDITAR) {
            actualizarcliente();


        }
        if (requestCode == 0) {


        }
    }



}