package com.example.ivan.ponsi;

import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Created by Ivan on 27/10/2015.
 */
public class FichaTareaGoteo extends ActionBarActivity {
    private long id;
    private int ids;
    private ViewGroup layout, layout_sec, layout_pro;
    LinearLayout nuevoLayout, nuevoLayout2;
    TextView nom,alias,paraje,finca;
    TextView titulo,fecha,observaciones,tiempo,coste, lectura;
    SimpleDateFormat formato = new SimpleDateFormat("HH:mm");

    TextView motivo,nom_comer,cantidad,dosis;
    TextView nom_sector, presio, abonadora;
    TextView dias, inicio, fin;
    private Tarea tarea = new Tarea();
    String[]  tiempo_s, dosis_s, abonadora_s, cantidad_s;


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        //cargamos el layout
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ficha_tarea_abono_reg);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);



        layout = (ViewGroup) findViewById(R.id.l_abono);
        layout_sec  = (ViewGroup) findViewById(R.id.l_sectores);
        tiempo_s =  getResources().getStringArray(R.array.tiempo);
        dosis_s = getResources().getStringArray(R.array.dosis_abono);
        abonadora_s = getResources().getStringArray(R.array.abonadora);
        cantidad_s = getResources().getStringArray(R.array.tipo_abono);


        //Referencio los editext y TextView estaticos
        nom = (TextView) findViewById(R.id.nom_f_t);
        alias = (TextView) findViewById(R.id.alias_f_t);
        paraje = (TextView) findViewById(R.id.paraje_f_t);
        finca = (TextView) findViewById(R.id.finca_f_t);
        titulo = (TextView) findViewById(R.id.titulo_f_t);
        fecha = (TextView) findViewById(R.id.fecha_f_t);
        observaciones = (TextView) findViewById(R.id.observaciones_f_t);
        tiempo = (TextView) findViewById(R.id.tiempo_f_t);
        coste = (TextView) findViewById(R.id.coste_f_t);
        lectura = (TextView) findViewById(R.id.lectura_c);

        actualizarvista();

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.ficha_tarea, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.informacion:
                Intent b = new Intent(this, InformacionTareaGoteo.class);
                startActivity(b);
                return true;

            case R.id.accion_editar:
                Intent i = new Intent(this, EditarTareaGoteo.class);
                i.putExtra("id", id);
                startActivityForResult(i,125);

                return true;
            case R.id.accion_borrar:

                new AlertDialog.Builder(this)
                        .setTitle("Borrar Tarea")
                        .setMessage("¿Seguro que quiere borrar esta Tarea?")
                        .setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                ConsultaBD.borrarTarea((int) id);
                                finish();
                            }
                        })
                        .setNegativeButton("Cancelar", null)
                        .show();

                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void actualizarvista(){

        tarea = ConsultaBD.Tarea((int)id);

        if(tarea != null){

            if (tarea.getNombre().equals("")){
                View vista = (View) nom.getParent();
                vista.setVisibility(View.GONE);
            }else{
                nom.setText(tarea.getNombre());
            }
            if (tarea.getAlia().equals("")){
                View vista = (View) alias.getParent();
                vista.setVisibility(View.GONE);
            }else{
                alias.setText(tarea.getAlia());
            }
            if (tarea.getParaje().equals("")){
                View vista = (View) paraje.getParent();
                vista.setVisibility(View.GONE);
            }else{
                paraje.setText(tarea.getParaje());
            }
            if (tarea.getFinca().equals("")){
                View vista = (View) finca.getParent();
                vista.setVisibility(View.GONE);
            }else{
                finca.setText(tarea.getFinca());
            }
            if (tarea.getTitulo().equals("")){
                View vista = (View) titulo.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) titulo.getParent();
                vista.setVisibility(View.VISIBLE);
                titulo.setText(tarea.getTitulo());
            }
            if (tarea.getObservaciones().equals("")){
                View vista = (View) observaciones.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) observaciones.getParent();
                vista.setVisibility(View.VISIBLE);
                observaciones.setText(tarea.getObservaciones());
            }
            if (tarea.getTiempo()==0){
                View vista = (View) tiempo.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) tiempo.getParent();
                vista.setVisibility(View.VISIBLE);
                tiempo.setText(Double.toString(tarea.getTiempo())+" "+tiempo_s[tarea.getsTiempo()]);
            }
            if (tarea.getCoste()==0){
                View vista = (View) coste.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) coste.getParent();
                vista.setVisibility(View.VISIBLE);
                coste.setText(Double.toString(tarea.getCoste()));
            }
            if(tarea.getFecha()==0){
                View vista = (View) fecha.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) fecha.getParent();
                vista.setVisibility(View.VISIBLE);
                fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
            }


        }

        //pongo la lectura del contador
        int lect = ConsultaBD.lecturaContador((int)id);
        if(lect==0){
            View vista = (View) lectura.getParent();
            vista.setVisibility(View.GONE);
        }else{
            lectura.setText(Integer.toString(lect));
        }


            //Implemento los sectores
        Cursor c1 = ConsultaBD.listadoSectores((int) id);

        while(c1.moveToNext()){
            //creo el layout
            LayoutInflater inflater = LayoutInflater.from(this);
            nuevoLayout = (LinearLayout) inflater.inflate(R.layout.ficha_sector_goteo, null, false);

            //Referencio los textview
            nom_sector = (TextView) nuevoLayout.findViewById(R.id.sector_f_g);
            presio = (TextView) nuevoLayout.findViewById(R.id.pres_f_g);
            abonadora = (TextView) nuevoLayout.findViewById(R.id.abonadora_f_g);
            layout_pro =   (ViewGroup) nuevoLayout.findViewById(R.id.l_programa);
            //Pongo el texto en los textview
            String cadena;
            int abonador;
            Double pres;

            cadena = c1.getString(c1.getColumnIndex("n_sector"));
            if(cadena.equals("")){
                View vista = (View) nom_sector.getParent();
                vista.setVisibility(View.GONE);
            }else{
                nom_sector.setText(cadena);
            }
           pres= c1.getDouble(c1.getColumnIndex("presio"));
            if(pres==0){
                View vista = (View) presio.getParent();
                vista.setVisibility(View.GONE);
            }else{
                presio.setText(Double.toString(pres));
            }
            abonador=c1.getInt(c1.getColumnIndex("abonadora"));
            if(abonador==0){
                View vista = (View) abonadora.getParent();
                vista.setVisibility(View.GONE);
            }else{
            abonadora.setText(Integer.toString(abonador) + " " + abonadora_s[c1.getInt(c1.getColumnIndex("t_abonadora"))]);
            }
            ids = c1.getInt(c1.getColumnIndex("sector_id"));

            //Implemento los programas
            Cursor c2 = ConsultaBD.listadoProgramas(ids);

            while(c2.moveToNext()){
                //creo el layout del programa
                LayoutInflater inflater2 = LayoutInflater.from(this);
                nuevoLayout2 = (LinearLayout) inflater2.inflate(R.layout.ficha_programa_goteo, null, false);

               // Referencio los textView
                dias = (TextView) nuevoLayout2.findViewById(R.id.dias_f_p);
                inicio = (TextView) nuevoLayout2.findViewById(R.id.hora1_f_p);
                fin = (TextView) nuevoLayout2.findViewById(R.id.hora2_f_p);

                //pongo el texto el los textviews
                String dies;
                dies=c2.getString(c2.getColumnIndex("dias"));
                if(dies.equals("")){
                    View vista = (View) dias.getParent();
                    vista.setVisibility(View.GONE);
                }else{
                dias.setText(dies);
                }
                inicio.setText(formato.format(new Date(c2.getLong(c2.getColumnIndex("desde"))))+" ");
                fin.setText(" " + formato.format(new Date(c2.getLong(c2.getColumnIndex("hasta")))));

                //añado el layout a la vista
                layout_pro.addView(nuevoLayout2);

            }
            c2.close();

            //añado el layout a la vista
            layout_sec.addView(nuevoLayout);



        }

        c1.close();


            //Implemento los abonos
        Cursor c = ConsultaBD.listadoAbonado((int)id);

        while(c.moveToNext()){
            //Creo el layout
            LayoutInflater inflater = LayoutInflater.from(this);
            nuevoLayout = (LinearLayout) inflater.inflate(R.layout.ficha_abono_solido, null, false);

            //Referencio los textview
            motivo = (TextView) nuevoLayout.findViewById(R.id.motivo_abo);
            nom_comer = (TextView) nuevoLayout.findViewById(R.id.nombre_abo);
            cantidad = (TextView) nuevoLayout.findViewById(R.id.cantidad_abo);
            dosis = (TextView) nuevoLayout.findViewById(R.id.dosis_abo);

            //Pongo el texto en los TextView String texto;
            String texto;
            Double valor;

            texto=c.getString(c.getColumnIndex("motivo"));
            if(texto.equals("")){
                View vista = (View) motivo.getParent();
                vista.setVisibility(View.GONE);
            }else{
                motivo.setText(texto);
            }
            texto=c.getString(c.getColumnIndex("nombre_a"));
            if(texto.equals("")){
                View vista = (View) nom_comer.getParent();
                vista.setVisibility(View.GONE);
            }else{
                nom_comer.setText(texto);
            }
            valor=c.getDouble(c.getColumnIndex("cantidad"));
            if(valor==0){
                View vista = (View) cantidad.getParent();
                vista.setVisibility(View.GONE);
            }else{
                cantidad.setText(Double.toString(valor)+" "+cantidad_s[c.getInt(c.getColumnIndex("t_cantidad"))]);
            }
            valor=c.getDouble(c.getColumnIndex("dosis"));
            if(valor==0){
                View vista = (View) dosis.getParent();
                vista.setVisibility(View.GONE);
            }else{
                dosis.setText(Double.toString(valor) + " " + dosis_s[c.getInt(c.getColumnIndex("dosis_s"))]);

            }
            //Añado el Layout a la vista
            layout.addView(nuevoLayout);


        }
        c.close();

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 125) {
            layout.removeAllViews();
            layout_sec.removeAllViews();
            actualizarvista();

        }
    }

}
