package com.example.ivan.ponsi;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.Date;

/**
 * Created by Ivan on 27/10/2015.
 */
public class FichaTareaOtros extends ActionBarActivity {
    private long id;

    TextView nom,alias,paraje,finca;
    TextView titulo,fecha,observaciones,tiempo,coste;

    TextView realizado;
    private Tarea tarea = new Tarea();
    String[] tiempo_s;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        //cargamos el layout
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ficha_tarea_otros);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);




        tiempo_s = getResources().getStringArray(R.array.tiempo);

        //Referencio los editext y TextView estaticos
        nom = (TextView) findViewById(R.id.nom_f_t);
        alias = (TextView) findViewById(R.id.alias_f_t);
        paraje = (TextView) findViewById(R.id.paraje_f_t);
        finca = (TextView) findViewById(R.id.finca_f_t);
        titulo = (TextView) findViewById(R.id.titulo_f_t);
        fecha = (TextView) findViewById(R.id.fecha_f_t);
        observaciones = (TextView) findViewById(R.id.observaciones_f_t);
        tiempo = (TextView) findViewById(R.id.tiempo_f_t);
        coste = (TextView) findViewById(R.id.coste_f_t);
        realizado = (TextView)findViewById(R.id.tarea_realizada_f_t);
        actualizarvista();

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.ficha_tarea, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.informacion:
                Intent b = new Intent(this, InformacionTareaOtros.class);
                startActivity(b);
                return true;

            case R.id.accion_editar:
                Intent i = new Intent(this, EditarTareaOtros.class);
                i.putExtra("id", id);
                startActivityForResult(i,125);

                return true;
            case R.id.accion_borrar:

                new AlertDialog.Builder(this)
                        .setTitle("Borrar Tarea")
                        .setMessage("¿Seguro que quiere borrar esta Tarea?")
                        .setPositiveButton("Confirmar", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                ConsultaBD.borrarTarea((int) id);
                                finish();
                            }
                        })
                        .setNegativeButton("Cancelar", null)
                        .show();

                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void actualizarvista(){

        tarea = ConsultaBD.Tarea((int)id);

        if(tarea != null){

            if (tarea.getNombre().equals("")){
                View vista = (View) nom.getParent();
                vista.setVisibility(View.GONE);
            }else{
                nom.setText(tarea.getNombre());
            }
            if (tarea.getAlia().equals("")){
                View vista = (View) alias.getParent();
                vista.setVisibility(View.GONE);
            }else{
                alias.setText(tarea.getAlia());
            }
            if (tarea.getParaje().equals("")){
                View vista = (View) paraje.getParent();
                vista.setVisibility(View.GONE);
            }else{
                paraje.setText(tarea.getParaje());
            }
            if (tarea.getFinca().equals("")){
                View vista = (View) finca.getParent();
                vista.setVisibility(View.GONE);
            }else{
                finca.setText(tarea.getFinca());
            }
            if (tarea.getTitulo().equals("")){
                View vista = (View) titulo.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) titulo.getParent();
                vista.setVisibility(View.VISIBLE);
                titulo.setText(tarea.getTitulo());
            }
            if (tarea.getObservaciones().equals("")){
                View vista = (View) observaciones.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) observaciones.getParent();
                vista.setVisibility(View.VISIBLE);
                observaciones.setText(tarea.getObservaciones());
            }
            if (tarea.getTiempo()==0){
                View vista = (View) tiempo.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) tiempo.getParent();
                vista.setVisibility(View.VISIBLE);
                tiempo.setText(Double.toString(tarea.getTiempo())+" "+tiempo_s[tarea.getsTiempo()]);
            }
            if (tarea.getCoste()==0){
                View vista = (View) coste.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) coste.getParent();
                vista.setVisibility(View.VISIBLE);
                coste.setText(Double.toString(tarea.getCoste()));
            }
            if(tarea.getFecha()==0){
                View vista = (View) fecha.getParent();
                vista.setVisibility(View.GONE);
            }else{
                View vista = (View) fecha.getParent();
                vista.setVisibility(View.VISIBLE);
                fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
            }

        }

        String realiz = ConsultaBD.textoOtros((int) id);
        if (realiz.equals("")){
            View vista = (View) realizado.getParent();
            vista.setVisibility(View.GONE);
        }else{
            View vista = (View) realizado.getParent();
            vista.setVisibility(View.VISIBLE);
            realizado.setText(realiz);
        }





    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 125) {

            actualizarvista();

        }
    }

}
